; *********************************************************************
; Animation data and macro
; *********************************************************************

Animation_compteur	set	0

ADD_ANIMATION	MACRO
	dc.w	\2	; Image de base
	dc.b	\3	; Nombre d'images : Max = 255
	dc.b	\4	; Nombre de frames : Max = 128
\1		set	Animation_compteur
Animation_compteur	set	Animation_compteur+4
		ENDM

; Animation table
Anim_table:
	ADD_ANIMATION	DEBOUT,0,1,10
	ADD_ANIMATION	HAUT,19,1,10
	ADD_ANIMATION	BAS,18,1,10
	ADD_ANIMATION	WAIT,1,2,20
	ADD_ANIMATION	WALK,3,6,4
	ADD_ANIMATION	RUN,28,4,2
	ADD_ANIMATION	BOULE,20,8,2
	ADD_ANIMATION	R_WALK,9,6,4
	ADD_ANIMATION	R_RUN,32,4,2
	ADD_ANIMATION	R_BOULE,20,8,2
	ADD_ANIMATION	RF_WALK,43,6,4
	ADD_ANIMATION	RF_RUN,49,4,2
	ADD_ANIMATION	RF_BOULE,20,8,2
	ADD_ANIMATION	RG_WALK,53,6,4
	ADD_ANIMATION	RG_RUN,59,4,2
	ADD_ANIMATION	RG_BOULE,20,8,2
	ADD_ANIMATION	BUMP,15,1,20
	ADD_ANIMATION	DEAD,16,1,20
	ADD_ANIMATION	OUILLE,17,1,20
	ADD_ANIMATION	FREINE,38,2,10
	ADD_ANIMATION	EQUILI,36,2,20
	ADD_ANIMATION	SPEED_UP,40,3,2
	ADD_ANIMATION	POUSSE,63,1,10
	ADD_ANIMATION	BUMP_2,64,12,2
	ADD_ANIMATION	VROT,75,12,4
	ADD_ANIMATION	SUSPENDU,93,1,10
	ADD_ANIMATION	ACCROCHER,87,6,4
	ADD_ANIMATION	TRAP_BH,94,6,4
	ADD_ANIMATION	TRAP_HB,97,6,4

	ADD_ANIMATION	ANI_BSTAR,6,2,4
	ADD_ANIMATION	ANI_STAR,5,1,10
	ADD_ANIMATION	ANI_EXP1,8,3,6
	ADD_ANIMATION	ANI_SHIELD,0,2,4
	ADD_ANIMATION	ANI_PANNEAU1,0,1,10
	ADD_ANIMATION	ANI_PANNEAU2,0,6,2
	ADD_ANIMATION	ANI_PANNEAU3,3,1,10


; Do the animation .
; DO_ANIMATION <bge> to print only the sprites with 'Type_aff < 0'
; At least one sprite ! ! !
DO_ANIMATION	MACRO
	lea	Draw_table(PC),a4	; a4 -> Sprite routine table
	move.l	Sprite_adr(a6),a5	; a5 -> Sprite buffer
	lea	Drawing(a5),a5		; A5 -> In, to go faster
	move.l	Sprite_end_adr(a6),d5	; D5 = Adress of the end of the sprite buffer
\@next:	move.b	Drawing-Drawing(a5),d2	; Get the print-type of the sprite
	\1.s	\@no			; >=0 or <=0 ?
	move.w	Xj-Drawing(a5),d0	; No, so read X
	move.w	Yj-Drawing(a5),d1	; and Y
	and.w	#%0000000001111110,d2	; Mask
	move.w	0(a4,d2.w),d2		; Get the offset
	jsr	0(a4,d2.w)		; jump to the sub-routine
\@no:	add.w	Taille-Drawing(a5),a5	; Next sprite
	cmp.l	d5,a5			; End of the sprite buffer ?
	blt.s	\@next			; No so continue the loop
		ENDM
	subq.w	#1,Ani_cpt-Drawing(a5)
; Calculate the next animation
CALC_ANI	MACRO
	move.l	Ani_adr-Drawing(a5),a3
	move.w	Ani-Drawing(a5),d3	; Get the animation's type.
	move.b	Animation-Drawing(a5),d2 ; Get the current sub-animation
Ani_dec_cpt_\1
	subq.b	#2,Ani_cpt-Drawing(a5)	; Decremente the waiting.
	bgt.s	\@ok			; >0 so it is still this sub-animation.
		addq.b	#1,d2		; Next sub-animation
		move.b	3(a3,d3.w),Ani_cpt-Drawing(a5)	; Reset the clock
\@ok:	cmp.b	2(a3,d3.w),d2		; Compare to the max sub-animation
	blt.s	\@bth			; No, ok !
		clr.b	d2		; Reset to the beginning
\@bth:	move.b	d2,Animation-Drawing(a5) ; Save the sub-animation
	ext.w	d2
	add.w	0(a3,d3.w),d2		; Get the image of the animation and the sub-animation
		ENDM

; Draw code table
Draw_table:
	dc.w	TypeRien-Draw_table	; 0
	dc.w	TypeRien-Draw_table	; 2
	dc.w	TypeRien-Draw_table	; 4
	dc.w	TypeRien-Draw_table	; 6

	dc.w	TypeS16-Draw_table	; 8
	dc.w	TypeS16h-Draw_table	; 10
	dc.w	TypeS16v-Draw_table	; 12
	dc.w	TypeS16hv-Draw_table	; 14

	dc.w	TypeBg-Draw_table	; 16
	dc.w	TypeBgh-Draw_table	; 18
	dc.w	TypeBgv-Draw_table	; 20
	dc.w	TypeBghv-Draw_table	; 22

	dc.w	TypeS16wo-Draw_table	; 24
	dc.w	TypeS16hwo-Draw_table	; 26
	dc.w	TypeS16vwo-Draw_table	; 28
	dc.w	TypeS16hvwo-Draw_table	; 30

	dc.w	TypeBgwo-Draw_table	; 32
	dc.w	TypeBghwo-Draw_table	; 34
	dc.w	TypeBgvwo-Draw_table	; 36
	dc.w	TypeBghvwo-Draw_table	; 38

	dc.w	TypeExe-Draw_table	; 40
	dc.w	TypeExe-Draw_table	; 42
	dc.w	TypeExe-Draw_table	; 44
	dc.w	TypeExe-Draw_table	; 46

TypeRien:	rts

; Standart put 16x16 sprite
TypeS16:
	CALC_ANI 0
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16

; Put 16x16 sprite with horizontal flipping
TypeS16h:
	CALC_ANI 1
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_h

; put 16x16 sprite with vertical flipping
TypeS16v:
	CALC_ANI 2
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_v

; put 16x16 sprite with vertical and horizontal flipping
TypeS16hv:
	CALC_ANI 3
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_hv


; Standart put 16x16 sprite
TypeS16wo:
	move.w	Ani-Drawing(a5),d2
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16

; Put 16x16 sprite with horizontal flipping
TypeS16hwo:
	move.w	Ani-Drawing(a5),d2
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_h

; put 16x16 sprite with vertical flipping
TypeS16vwo:
	move.w	Ani-Drawing(a5),d2
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_v

; put 16x16 sprite with vertical and horizontal flipping
TypeS16hvwo:
	move.w	Ani-Drawing(a5),d2
	move.l	Dessin-Drawing(a5),genlib::sprite_tile_adr
	jmp	genlib::put_sprite_16_flip_hv


; Put a 'big' sprite
TypeBg:
	CALC_ANI 4
	add.w	d2,d2		; 2 * D2
	move.l	Dessin-Drawing(a5),a0
	move.w	0(a0,d2.w),d2	; Get the offset
	add.w	d2,a0		; Get the adress
	jmp	genlib::put_big_sprite

; Put a big sprite with h flipping
TypeBgh:
	CALC_ANI 5
	add.w	d2,d2		; 2* D2
	move.l	Dessin-Drawing(a5),a1
	move.w	0(a1,d2.w),d2	; Offset
	add.w	d2,a1		; Image
	lea	Free_buffer(a6),a0	; Free buffer
	jmp	genlib::put_big_sprite_flip_h

; Etc
TypeBgv:
	CALC_ANI 6
	add.w	d2,d2
	move.l	Dessin-Drawing(a5),a1
	move.w	0(a1,d2.w),d2
	add.w	d2,a1
	lea	Free_buffer(a6),a0
	jmp	genlib::put_big_sprite_flip_v

TypeBghv:
	CALC_ANI 7
	add.w	d2,d2
	move.l	Dessin-Drawing(a5),a1
	move.w	0(a1,d2.w),d2
	add.w	d2,a1
	lea	Free_buffer(a6),a0
	jmp	genlib::put_big_sprite_flip_hv

; Put a 'big' sprite with no calcul of animation
TypeBgwo:
	move.l	Dessin-Drawing(a5),a0
	jmp	genlib::put_big_sprite

; Put a big sprite with h flipping
TypeBghwo:
	move.l	Dessin-Drawing(a5),a1
	lea	Free_buffer(a6),a0	; Free buffer
	jmp	genlib::put_big_sprite_flip_h

; Etc
TypeBgvwo:
	move.l	Dessin-Drawing(a5),a1
	lea	Free_buffer(a6),a0
	jmp	genlib::put_big_sprite_flip_v

TypeBghvwo:
	move.l	Dessin-Drawing(a5),a1
	lea	Free_buffer(a6),a0
	jmp	genlib::put_big_sprite_flip_hv

TypeExe:
	move.l	Gfx_adr-Drawing(a5),a0
	jmp	(a0)
