; *********************************************************************
; 			Main Engine // main loop
; *********************************************************************

; In :  d5.l = Start
;	a5.l -> Level
; Out :	d6.l = Current position

exec_level:
	; Set vars
	move.l	a5,Level_adr(a6)	; Save the adress of the level
	moveq	#0,d7			; Clear time
	move.b	SX1(a5),d7		; Read SX1 in d7

	; Set the main flags
	clr.b	Alignement(a6)	
	st.b	Refresh_window(a6)
	move.b	FLAG_EXTRA(a5),FlagWB(a6)

	; Reset SIN cpt
	clr.l	Current_SIN(a6)

	; Reset the 'Print' function
	clr.w	Current_y(a6)
	jsr	tios::ScreenClear

	; Print 'Loading'
	lea	Loading_str(Pc),a0
	bsr	Print

	; Print the name of the level
	lea	LEVEL_NAME(a5),a0
	bsr	Print

	; Tata init
	bsr	set_plane1
		; A modifier lors du changement de gestion des tables !
		lea	Inc_Vitesse-8(Pc),a0	; On remet la table normale
		lea	Inc_Vitesse_normal(Pc),a1
		move.l	(a1)+,(a0)+
		move.l	(a1),(a0)+
		move.l	(a1),(a0)+
		move.l	-(a1),(a0)+

	; Calculate the horizontal lenght
	moveq	#1,d1
	lsl.w	d7,d1
	move.w	d1,Len_x(a6)
	move.w	d1,d0		; Save for calc Mask

	; Calculate a mask for 'check-sprite' routine
	mulu.w	#SCREEN_Y/16,d1
	move.w	d1,Check_offset(a6)

	subq.w	#1,d0
	move.w	d0,Mask_x(a6)

	; Set and calculate scrolling's data
	clr.w	Scroll_ax(a6)
	clr.w	Scroll_ay(a6)
	clr.w	Scroll_cpt(a6)

	tst.b	Calc(a6)
	bne.s	\92p
		move.w	#(160/2),Center_x(a6)		; 160/2-8
		move.w	#(100/2+20),Center_y(a6)	; 100/2-16
		move.w	#160,d3
		move.w	#100,d4
		bra.s	\done
\92p:	move.w	#(240/2),Center_x(a6)			; 240/2-8
	move.w	#(128/2+20),Center_y(a6)		; 128/2-32
	move.w	#240,d3
	move.w	#128,d4
\done:

	; Set the limits of the scrolling
	clr.w	xmin(a6)
	clr.w	ymin(a6)
	moveq	#1,d0
	lsl.l	d7,d0	; cell
	lsl.l	#4,d0	; pixel
	sub.w	d3,d0
	move.w	d0,xmax(a6)
	moveq	#0,d1
	move.b	SY1(a5),d1
	lsl.w	#4,d1	; pixel
	sub.w	d4,d1
	move.w	d1,ymax(a6)

	; Calculate the difference between the 2 planes (A & B)
	move.b	SY2(a5),d1
	move.b	SY1(a5),d0
	clr.b	d2
\loop_d:
		cmp.b	d0,d1
		bhi.s	\end_d		; Le gros problme est qu'on perd une grosse partie
		add.b	d1,d1		; Du 2eme plan.
		ble.s	\end_d2		; Attention depassement de capacite au prochain coup !
		addq.b	#1,d2
		bra.s	\loop_d
\end_d2:
	addq.b	#1,d2			; Merde.
\end_d:	move.b	d2,Diff_y(a6)

	; Reset rings
	clr.w	Ring(a6)
	move.w	#100,Ring_to_life(a6)
	move.w	#30000,Water_level(a6)		; Default water level

	; Allocate Plane A
	lea	Ext_gfx_str(Pc),a0
	bsr	Print

	; Allocathe the gfx of the plane A
	lea	GFX1_FILENAME(a5),a0
	bsr	search_graph_file

	move.l	a0,Gfx1_adr(a6)
	move.l	a0,a4			; Tile for plane
;	lea	smalib@0006,a0		; Source : pached data (tile base)
	exg	d5,d4
	moveq	#5,d5
	bsr	deref_data		; Source : packed data
	exg	d5,d4
	move.l	a4,a1			; Dest   : if 0, create a new handle !
	bsr	do_shk			; Copy base-tiles !

	; Allocate memory to save the plane A table
	lea	Init_plane_str(Pc),a0
	bsr	Print

	moveq	#1,d0
	lsl.w	d7,d0
	moveq	#0,d1
	move.b	SY1(a5),d1
	mulu.w	d1,d0		; Sx * Sy
	move.w	d0,Sub_lev_size(a6)

	moveq	#0,d4
	move.w	d0,d4		; d4 = Sx * Sy
		tst.b	FlagWB(a6)
		beq.s	\no_word
			add.w	d4,d4 ; d4 = 2*sx*sy
\no_word
	add.l	d4,d0		; {2,3} * Sx * Sy
	bsr	Alloc

	; Allocate plane A
	move.l	a0,a3
	move.l	a0,Graph_adr(a6)
	adda.l	d4,a0
	move.l	a0,Test_adr(a6)

	move.l	a5,-(a7)		; Save a5 since we need it
	suba.l	a5,a5			; No indirect table
	move.b	d7,d3			; Plane is 2^d7 bytes long
	jsr	genlib::init_plane	; Init the plane
	tst.w	d0			; test : memory ?
	beq	Memory			; Yes
	bsr	push_hd			; Save handle
	move.l	a0,Plan_A_adr(a6)	; Save the adress of the plane
	move.l	(a7)+,a5		; Restore a5

	; Allocate plane B
	lea	Ext_gfx_str(Pc),a0
	bsr	Print
	
	; Compare the name : same ?
	lea	GFX2_FILENAME(a5),a0
	move.l	a0,a1
	move.l	GFX1_FILENAME(a5),d0
	cmp.l	(a1)+,d0
	bne.s	\extr
	move.l	GFX1_FILENAME+4(a5),d0
	cmp.l	(a1),d0
	bne.s	\extr
	move.l	Gfx1_adr(a6),a0
	bra.s	\don
\extr:	bsr	search_graph_file	; No so we search and allocate it !
\don:	move.l	a0,Gfx2_adr(a6)		; Yes, same source
	move.l	a0,a4			; Tile for plane

	; Extracting the table of the plane B if 2 planes !
	lea	Free_buffer(a6),a0	; A0 -> free buffer to avoid some problems !
	move.b	Print_opt(pC),d0
	bne.s	\no_alloc_for_plane_B

		lea	Extracting_str(Pc),a0
		bsr	Print

		lea	DATA(a5),a0
		moveq	#0,d0			; File 0
		jsr	pk92lib::Extract
		tst.b	d0
		bne	Memory
		move.l	a1,a3
		bsr	push_hd1

		; Init plane B
		lea	Init_plane_str(Pc),a0
		bsr	Print

		move.l	a5,-(a7)
		move.b	SX2(a5),d3		; Plane is 2^?? bytes long
		suba.l	a5,a5			; No indirect table
		jsr	genlib::init_plane	; Init the plane
		tst.w	d0			; test : memory ?
		beq	Memory			; Yes
		bsr	push_hd			; Save handle
		move.l	(a7)+,a5
\no_alloc_for_plane_B:
	move.l	a0,Plan_B_adr(a6)	; Save the adress of the plane

	; Allocate the anim-table file
	lea	Anim_base(Pc),a0
	move.w	DATA+2+2*3(a5),d0	; Utilise le format de pk92lib !!
	sub.w	DATA+2+2*2(a5),d0	
	subq.w	#2,d0			; S'il y a juste la taille, (et qu'elle est nulle)
	beq.s	\std_anim_file
		lea	DATA(a5),a0
		moveq	#2,d0			; File 2
		jsr	pk92lib::Extract
		tst.b	d0
		bne	Memory
		move.l	a1,a0			; New anim file
		bsr	push_hd1
\std_anim_file
	move.l	a0,Anim_tile_adr(a6)

	; Allocate the sprite_buffer
	ifeq	OS	; Ti-89 & Ti-92+
	lea	Alloc_mem_str(Pc),a0
	bsr	Print
	move.l	#(SIZE_SPRITE_BUFFER+MAX_SPRITE),d0
	bsr	Alloc
	endif
	ifne	OS	; Ti-92
	move.l	tios::Heap,a0 ; Insert tios::DEREF Macro
	adda.w	#4*HANDLEIO,a0
	move.l	(a0),a0		; and optimize it to be shorter...
;	move.l	4*HANDLEIO(a0),a0
	addq.l	#4,a0		; I/O screen
	endif
	move.l	a0,Sprite_adr(a6)

	; Allocate the clear-buffer
	lea	Creating_clear_buffer_str(Pc),a0
	bsr	Print
	
	moveq	#0,d0
	moveq	#0,d1
	move.b	MX1(a5),d0
	move.b	MY1(a5),d1
	mulu.w	d1,d0
	move.w	Sub_lev_size(a6),d1	; d1 = 16 * Number...
	lsr.w	#3,d1		; D1 = 2x Number
	mulu.l	d1,d0		; D0 = 2x Number'
	move.l	d0,d4		; D4 = temp save
	bsr	Alloc
	move.l	a0,Clear_buffer_adr(a6)

	lsr.w	#1,d4		; Number
	subq.w	#1,d4		; For dbf
\loop:		clr.w	(a0)+
		dbf.s	d4,\loop

	; Resolving external calls
	lea	Destroy_sprite(pc),a0
	move.l	a0,Destroy_sprite_adr(a6)
	lea	Init_sprite(Pc),a0
	move.l	a0,Init_sprite_adr(a6)
	lea	Surface_A_table(Pc),a0
	move.l	a0,Surface_table(a6)
	lea	Calcul_surface_A(Pc),a0
	move.l	a0,Calc_surface_adr(a6)
	lea	random(Pc),a0
	move.l	a0,Random_adr(a6)
	move.l	#genlib::draw_clipped_line,Line_adr(a6)
	move.l	#genlib::draw_clipped_circle,Circle_adr(a6)

	; Read and set the external sprites
	clr.l	External_sprite_adr(a6)
	lea	SPRITE_FILENAME(a5),a0
	bsr	search
	tst.w	d0
	beq.s	\not_found
	move	SYM_ENTRY.hVal(a0),d1	;Get handle of file in d1
	tios::DEREF	d1,a1
	addq.l	#2,a1
	move.l	(a1)+,d0
	cmp.l	#('SXES'),d0
	bne.s	\not_found
	ifeq	OS		; For 89/92p only
		cmp.l	#$200000,a1
		bls.s	\ram_var	; Archived variable. Copy...
			lea	Copy_sprite_file_str(Pc),a0
			bsr	Print
			moveq	#0,d3
			lea	-(2+4)(a1),a3
			move.w	(a3),d3		; Load size of the variable
			addq.l	#3,d3
			move.l	d3,d0
			bsr	Alloc
		        move.l	a0,a1		; a5 : destination
		        subq.l	#1,d3
\cpy				move.b	(a3)+,(a1)+      ; copy to RAM
        			dbra	d3,\cpy
			lea	2+4(a0),a1
\ram_var:
	endif
	move.l	a1,External_sprite_adr(a6)

	; Relocation and copy of the external sprite table...
	lea	Reloc_sprite_file_str(Pc),a0
	bsr	Print
	lea	(Sprite_table+16)(Pc),a0
	move.l	a1,d4
	subq.l	#4,d4			; For relocation correction
	moveq	#(16+8-1),d0		; (16+8-1)
\copy_loop:
		addq.l	#4,a1
		addq.l	#4,a0
		move.l	(a1)+,(a0)+		; Size.w / Dx.b / Dy.b
		move.l	(a1)+,(a0)+		; FeedBack / Type_aff / Ani
		move.l	(a1)+,d1
		add.l	d4,d1			; Relocation
		move.l	d1,(a0)+		; Gfx_table
		dbf.s	d0,\copy_loop
\not_found:

	; Calculate the starting point
	; Which sub-level ?
	move.l	d5,d0
	lsr.w	#8,d0			; Sub y
	move.b	d0,Sub_lev_y(a6)
	rol.l	#8,d0			; Sub x
	move.b	d0,Sub_lev_x(a6)
	
	; Calculate the coordinates of the starting point
	moveq	#0,d6
	moveq	#0,d1
	move.b	d5,d1
	lsl.w	#4,d1
	move.w	d1,d6
	swap	d6
	swap	d5
	moveq	#0,d1
	move.b	d5,d1
	lsl.w	#4,d1
	move.w	d1,d6
	swap	d6	; D6 -> Point de dpart !
	; D6.l = Staring point

	; Init time data
	clr.w	minute(a6)
	clr.w	seconde(a6)
	clr.w	centieme(a6)

	ifne	DEBUG
		jsr	genlib::wait_a_key
	endif
	bsr	draw_window

	; Init sprite buffer
	move.l	Sprite_adr(a6),Sprite_end_adr(a6)

	; Init sonic sprite
	moveq	#SPR_SONIC,d2	; d2.l but we need only d2.w
	bsr	Init_sprite
	
	; Init the special effects (in function of P1_TYPE and P2_TYPE).
	st.b	Calc_B(a6)		; Calc coordinate of Plane B
	clr.l	Dhz_A_table(a6)
	clr.l	Dhz_B_table(a6)
	clr.l	Hdz_A_table(a6)
	clr.l	Hdz_B_table(a6)
	
	move.b	GFX1_TYPE(a5),d0
	beq.s	no_special_effect_1
		moveq	#0,d4 		;To plane A
		cmp.b	#1,d0
		bne.s	\next
			moveq	#SPR_SPECIAL4,d2
			bsr	Init_sprite
\next:
		cmp.b	#2,d0
		bne.s	\next2
			moveq	#SPR_SPECIAL1,d2
			bsr	Init_sprite
\next2:
no_special_effect_1:
	move.b	GFX2_TYPE(a5),d0
	beq.s	\no_special_effect_2
		moveq	#1,d4	;To plane B
		cmp.b	#1,d0
		bne.s	\next2
			moveq	#SPR_SPECIAL2,d2
			bsr	Init_sprite
			bra.s	\no_special_effect_2
\next2:
		cmp.b	#2,d0
		bne.s	\next3
			moveq	#SPR_SPECIAL3,d2
			bsr	Init_sprite
\next3:
		cmp.b	#3,d0
		bne.s	\next4
			moveq	#SPR_SPECIAL5,d2
			bsr	Init_sprite
\next4:
		cmp.b	#4,d0
		bne.s	\next5
			moveq	#SPR_SPECIAL6,d2
			bsr	Init_sprite
\next5:
\no_special_effect_2:

Start_sub_level:
;\wait	bra.s	\wait
	; Calcul du sous-niveau
	moveq	#0,d0
	moveq	#0,d1
	move.l	Level_adr(a6),a5	; Because we can lose it !
	move.b	MX1(a5),d0
	move.b	Sub_lev_y(a6),d1
	mulu.w	d0,d1
	add.b	Sub_lev_x(a6),d1	; D1 = Sub_lev_y * MX1 + Sub_lev_x
	moveq	#0,d4
	move.b	d1,d4
	addq.w	#3,d1			; Attention : limite de 256 sous-niveaux (+ tard...)

	; Calcul of Clear_level_adr
	move.w	Sub_lev_size(a6),d2
	lsr.w	#3,d2			; Subsize / 8
	mulu.w	d2,d4
	move.l	Clear_buffer_adr(a6),a0
	add.l	d4,a0
	move.l	a0,Clear_level_adr(a6)

	; Extraction sous-niveau
	move.l	Level_adr(a6),a0
	lea	DATA(a0),a0
	move.w	d1,d0		; D0 = No of file
	move.l	Plan_A_adr(a6),a1
	move.l	PLANE_TABLE_ADR(a1),a1
	jsr	pk92lib::ExtractA
	tst.b	d0
	bne	Internal

	; Restore data using the link table...
	; Allocate link-table
	tst.b	FlagWB(a6)
	bne.s	\gfx_word

		moveq	#1,d0			; File 1 : Link table
		move.l	Level_adr(a6),a0
		lea	DATA(a0),a0
		lea	Free_buffer(a6),a1
		jsr	pk92lib::ExtractA	; Extract in the free buffer (256 bytes)
		tst.b	d0
		bne	Internal
		move.l	a1,a0			; A0 -> Link table

		; Restore data...
		move.l	Test_adr(a6),a1
		move.l	Graph_adr(a6),a2
		move.w	Sub_lev_size(a6),d0	; 2^Sx * Sy
		subq.w	#1,d0			; For dbf
		moveq	#0,d1			; Since we use (a0,d1.w)
		moveq	#-1,d2			; D2.b  = 255
\loop_ho:
			move.b	(a2)+,d1		; Read graph
			cmp.b	(a1)+,d2		; If (Test_tab[i] == 255) Test_tab[i] = Link_tab[Gfx_tab[i]];
			bne.s	\ok
				move.b	0(a0,d1.w),-1(a1)	; Test_tab[i] = Link_tab[Gfx_tab[i]]
\ok:			dbf.s	d0,\loop_ho
\gfx_word:

	; Update data using the clear-buffer
	move.l	Clear_level_adr(a6),a0
	move.l	Test_adr(a6),a1
	move.l	Graph_adr(a6),a2
	moveq	#0,d1

	move.w	Sub_lev_size(a6),d0
	lsr.w	#3,d0
	subq.w	#1,d0
\loop_clear:
		moveq	#(8-1),d2	; D2 = compteur
		moveq	#0,d3		; D3 = bit a lire
\sub_loop_clear
			btst.b	d3,(a0)		; Test
			beq.s	\no_clear_data
				move.b	0(a1,d1.w),d4		; D4.b = Object
				clr.b	0(a1,d1.w)
				cmp.b	#OBJ_EXT0/4-1,d4		; If ext sprite, no clear graph
				bls.s	\clr_it
					cmp.b	#OBJ_EXTF/4+1,d4
					bls.s	\no_clear_data
\clr_it:					tst.b	FlagWB(a6)	; Si c'est en word, 
						bne.s	\wd
							clr.b	0(a2,d1.w)	; Octet
							bra.s	\no_clear_data
\wd						add.w	d1,d1
						clr.w	0(a2,d1.w)		; Word
						lsr.w	#1,d1
\no_clear_data:
			addq.w	#1,d1		; Next offset in big sub-level
			addq.w	#1,d3		; Next bit a lire
			dbf.s	d2,\sub_loop_clear
		addq.w	#1,a0		; Next adress
		dbf.s	d0,\loop_clear

	; Init all sprites in the screen
	bsr	Init_all_sprites

	clr.l	key_mask(a6)	
	clr.b	Exit(a6)
	clr.b	All_window(a6)
	
	; Select the print_way
	moveq	#0,d0
	move.b	Print_opt(Pc),d0
	tst.b	Calc(a6)
	beq.s	\no_add
		addq.w	#2,d0
\no_add	lea	Print_tab(Pc),a0
	move.w	0(a0,d0.w),d0
	move.w	d0,Print_way(a6)

	; Warning : Warning : Warning : Warning :
	; Boucle principale !!!!!
main_loop:
	; Lecture des touches + gestion reappuie
	out	#$A0
	jsr	genlib::read_joypad
	move.l	d0,d2
	move.l	key_mask(a6),d1
	or.l	d1,d0
	move.l	d0,key(a6)
	not.l	d2
	and.l	d2,d1
	move.l	d1,key_mask(a6)
	
	; Test touches speciales
	and.w	#%01111,d0
	cmp.w	#%01111,d0
	beq.s	\no_special_key

	btst.b	#exit_key,d0		; Test exit key
	bne.s	\no_exit
		move.b	#QUIT,Exit(a6)
\no_exit:
	btst.b	#plus_key,d0
	bne.s	\no1
		moveq	#09,d0	; 9=contrast_up
		trap	#9	; trap
		jsr	(a0)	; call rom
		bset.b	#plus_key,(key_mask+3)(a6)
		bra.s	\no_special_key
\no1:
	btst.b	#minus_key,d0
	bne.s	\no2
		moveq	#10,d0	; 10=contrast_down
		trap	#9
		jsr	(a0)
		bset.b	#minus_key,(key_mask+3)(a6)	
		bra.s	\no_special_key
\no2:
	btst.b	#mode_key,d0
	bne.s	\no3
		trap	#4
\no3:
\no_special_key:

	; Determine s'il faut ou non inialiser de nouveaux sprites
	out	#$A1
	bsr	Check_new_sprites

	; Gestion des sprites
	out	#$A2
	bsr	gestion_sprites		; Exec all the Sprites

	tst.b	Exit(a6)
	bne	do_done

	out	#$A3
	bsr	Tiles_animation		; Animation of the tiles

	out	#$A4
	bsr	gere_scrolling		; Update scrolling data of plane A & B

	out	#$A5
	move.l	Plan_A_adr(a6),a0
	jsr	genlib::copy_xyplane_xysprite	; Update scrolling data of sprite-plane
	lea	genlib::update_vscreen_16,a1
	tst.b	FlagWB(a6)
	beq.s	\load_done
		lea	genlib::update_vscreen_max16,a1
\load_done
	jsr	(a1)
	move.w	Print_way(a6),d0
	jsr	Print_tab(Pc,d0.w)

	out	#$A6
	swap	d7
	addq.w	#2/TURBO,d7			; Next time
	swap	d7

	bsr	calcul_time		; Calcul the time (min,sec)
	bsr	print_data		; Print data (time,ring,life)
	
	DOUBLE_BUFFER			; Exchange the DScreens

wait_frame_dat:
\wait:	cmp.l	#6-1,genlib::timer
	bls.s	\wait			; 15 Hz waiting
	clr.l	genlib::timer
\skip_wait:

	bra	main_loop

Print_tab:
	dc.w	Print_2x_89-Print_tab
	dc.w	Print_2x_92-Print_tab
	dc.w	Print_1x_89-Print_tab
	dc.w	Print_1x_92-Print_tab

Print_2x_89:
	ifeq	OS
	move.l	Plan_B_adr(a6),a0	
	jsr	genlib::update_roll_vscreen_16
\wait:		tst.l	genlib::timer
		beq.s	\wait
	move.l	Dhz_B_table(a6),d0
	beq.s	\standart
	move.l	d0,a4
	move.l	Hdz_B_table(a6),A5
	jsr	genlib::put_dhz_plane_89
	bra.s	\put_B_done
\standart:
	jsr	genlib::put_plane_89
\put_B_done:

	DO_ANIMATION	bge		; Put the sprite in plane 2

	move.l	Plan_A_adr(a6),a0
	move.l	Dhz_A_table(a6),d0
	beq.s	\put_standart
	movem.l	d7/a6,-(a7)
	move.l	Hdz_A_table(a6),d7
	move.l	d0,a6	
	jsr	genlib::put_dhz_fgrd_plane_89
	movem.l	(a7)+,d7/a6
	bra.s	\put_A_done
\put_standart:
	jsr	genlib::put_fgrd_plane_89
\put_A_done:

	DO_ANIMATION	ble		; Put the sprite in plane 1
	rts
	endif

Print_2x_92:
	move.l	Plan_B_adr(a6),a0
	jsr	genlib::update_roll_vscreen_16
;	jsr	genlib::update_vscreen_max16
	
\wait:		tst.l	genlib::timer
		beq.s	\wait

	move.l	Dhz_B_table(a6),d0
	beq.s	\standart
		move.l	d0,a4
		move.l	Hdz_B_table(a6),A5
		jsr	genlib::put_dhz_plane
		bra.s	\put_B_done
\standart:
	jsr	genlib::put_plane
\put_B_done:

	DO_ANIMATION	bge

	move.l	Plan_A_adr(a6),a0

	move.l	Dhz_A_table(a6),d0
	beq.s	\put_standart
	movem.l	d7/a6,-(a7)
	move.l	Hdz_A_table(a6),d7
	move.l	d0,a6	
	jsr	genlib::put_dhz_fgrd_plane
	movem.l	(a7)+,d7/a6
	bra.s	\put_A_done
\put_standart:
	jsr	genlib::put_fgrd_plane
\put_A_done:
	
	DO_ANIMATION	ble		; Put the sprite in plane 1
	rts

Print_1x_89:
	ifeq	OS
\wait:		tst.l	genlib::timer
		beq.s	\wait

	jsr	genlib::cls

	DO_ANIMATION	bge		; Put the sprite in plane 2

	move.l	Plan_A_adr(a6),a0
	move.l	Dhz_A_table(a6),d0
	beq.s	\put_standart
		movem.l	d7/a6,-(a7)
		move.l	Hdz_A_table(a6),d7
		move.l	d0,a6	
		jsr	genlib::put_dhz_fgrd_plane_89
		movem.l	(a7)+,d7/a6
		bra.s	\put_A_done
\put_standart:
	jsr	genlib::put_fgrd_plane_89
\put_A_done:

	DO_ANIMATION	ble		; Put the sprite in plane 1
	rts
	endif

Print_1x_92:
\wait:		tst.l	genlib::timer
		beq.s	\wait

	jsr	genlib::cls

	DO_ANIMATION	bge

	move.l	Plan_A_adr(a6),a0
	move.l	Dhz_A_table(a6),d0
	beq.s	\put_standart
		movem.l	d7/a6,-(a7)
		move.l	Hdz_A_table(a6),d7
		move.l	d0,a6	
		jsr	genlib::put_dhz_fgrd_plane
		movem.l	(a7)+,d7/a6
		bra.s	\put_A_done
\put_standart:
	jsr	genlib::put_fgrd_plane
\put_A_done:
	
	DO_ANIMATION	ble		; Put the sprite in plane 1
	rts

do_done:
	; Restore some task if debug
;	ifne	DEBUG
;	move.l	Plan_A_adr(a6),a0
;	move.l	Graph_adr(a6),PLANE_TABLE_ADR(a0)
;	move.l	Gfx1_adr(a6),PLANE_TILE_ADR(a0)
;	endif

	; Destroy all sprites which depends on 'offset'
	bsr	Destruction_sprites

	; New sub_level ?
	cmp.b	#NEXT,Exit(a6)
	beq	Start_sub_level
	
	jmp	genlib::free_hd		; Free all allocated handles

	