; *********************************************************************
; 			Main character.
;	Engine : version 9.5
; *********************************************************************

; Fichier d'entete contenant toutes les elements de la structure sprite_sonic.
 include "spr_sonc.h"

; Initialisation du personnage
sonic_init:
	; Set (X, Y) position
	move.l	d6,d0
	swap	d0
	addq.w	#8,d0
	swap	d0
	clr.w	d0
	move.l	d0,X(a5)
	move.w	d6,d0
	add.w	#16,d0
	swap	d0
	clr.w	d0
	move.l	d0,Y(a5)

	; Set other data
	clr.l	Vx(a5)	; vx
	clr.l	Vy(a5)	;vy
	clr.l	V(a5)	;v
	clr.l	Abs_v(a5)	;av
	clr.l	Jx(a5)	;jx
	clr.l	Jy(a5)	;jy
	clr.b	Boule(a5)	; boule
	clr.b	SSonic(a5)	;ssonic
	clr.w	S_cpt(a5)	; s
	clr.w	I_cpt(a5)	; i
	clr.w	C_cpt(a5)	; c
	clr.w	J_cpt(a5)	; j
	clr.w	W_cpt(a5)	; w
	move.w	#_TOMBE,Action(a5)
	clr.b	Shield(a5)	; Shield
;	clr.b	Qqchose(a5)	; ?
	clr.w	Diag(a5)

	move.l	#PESANTEUR,Pesanteur(a5)
	rts

sonic_exe:
	; Save the stack
	move.l	a7,Org_stack(a5)

	; Si on va assez vite, on aligne le scrolling pour aller plus vite !
;	cmp.w	#14,Abs_v(a5)
;	scc.b	Alignement(a6)	; 

	; End code of sonc
	pea	sonc_end(Pc)

	; Petit supplement pour debuggage
	; Permet de voir les veritables tests
	ifne	DEBUG
	move.l	key(a6),d0
;	btst.l	#kh_key,d0
;	bne.s	\no_kh
;	move.l	Plan_A_adr(a6),a0
;	move.l	Test_adr(a6),PLANE_TABLE_ADR(a0)
;	move.l	#Obj_gfx,PLANE_TILE_ADR(a0)
;\no_kh:	btst.l	#kd_key,d0
;	bne.s	\no_kd
;	move.l	Plan_A_adr(a6),a0
;	move.l	Graph_adr(a6),PLANE_TABLE_ADR(a0)
;	move.l	Gfx1_adr(a6),PLANE_TILE_ADR(a0)
;\no_kd:	
	; Deplacement ou bon te semble
	btst.l	#kg_key,d0
	bne.s	\no_kg
		clr.l	V(a5)
		move.w	#_TOMBE,Action(a5)
		btst.l	#up_key,d0
		bne.s	\no_up
			subq.w	#4,Y(a5)
\no_up:		btst.l	#down_key,d0
		bne.s	\no_down
			addq.w	#4,Y(a5)
\no_down:
		btst.l	#left_key,d0
		bne.s	\no_left
		subq.w	#4,X(a5)
\no_left:
		btst.l	#right_key,d0
		bne.s	\no_right
		addq.w	#4,X(a5)
\no_right:
		rts
\no_kg:
	endif

	; On appelle 2x la routine de dplacement si super- vitesse !
	tst.w	S_cpt(a5)
	beq.s	\1
	blt.s	\2
		subq.w	#1,S_cpt(a5)
\2:	move.w	speed_level(a6),d0
\2loop:	pea	move_sonic(Pc)
	dbf.s	d0,\2loop
\1:	move.w	speed_level(a6),d0
\1loop:	pea	move_sonic(Pc)
	dbf.s	d0,\1loop
	rts

; Code appelle une fois a la fin.
sonc_end:
	; Effectue la derniere phase de l'action en cours
	move.l	key(a6),d4
	lea	Action2_table(Pc),a0
	move.w	Action(a5),d0
	move.w	0(a0,d0.w),d0
	jsr	0(a0,d0.w)

	; Si on a le type WALK, on peut avoir en fait soit WALK, RUN ou BOULE
	move.w	Ani(a5),d3
	cmp.w	#WALK,d3
	bne.s	\normal
	; Marcher, courir ou bouler, il faut choisir !
	cmp.w	#RUN_LIMIT,Abs_v(a5)
	bls.s	\run_done
		moveq	#RUN,d3
\run_done:
	tst.b	Boule(a5)
	beq.s	\boule_done
		moveq	#BOULE,d3
\boule_done:
	; Ici D3.w vaut soit WLK, RUN ou BOULE, i.e. l'animation a utilise
	move.w	Diag(a5),d0
	lea	Diag_table(Pc),a0
	move.w	0(a0,d0.w),d0
	jsr	0(a0,d0.w)			; Saut au gestionnaire des dialogonales
	and.b	#%11111000,Type_aff(a5)
	or.b	d4,Type_aff(a5)			; Mise a jour du type d'affichage
	move.w	d3,Ani(a5)			; Sauvegarde l'animation
\normal:

	; Set (Xj, Yj)
	lea	Correction_table(Pc),a0		; Table de recentrage...
	move.b	Type_aff(a5),d4			; En fonction du flipping utilise

	move.b	0(a0,d3.w),d1
	btst.l	#Type_aff_H,d4
	beq.s	\no1
		move.b	1(a0,d3.w),d1
\no1:	ext.w	d1
	move.b	2(a0,d3.w),d2
	btst.l	#Type_aff_V,d4
	beq.s	\no2
		move.b	3(a0,d3.w),d2
\no2:	ext.w	d2

	move.w	X(a5),d0
	add.w	d1,d0
	move.w	d0,Xj(a5)			; Fixe la position Xj pour le sprite de Sonic

	move.w	Y(a5),d3
	add.w	d2,d3
	move.w	d3,Yj(a5)			; Fixe la position Yj pour le sprite de Sonic

	; Test retour de force ! Force = 0 rien, -1 si invicible, 1 si Ouille
	tst.b	Force(a5)
	ble.s	\no_tuch
	tst.w	C_cpt(a5)
	bne.s	\no_tuch
		tst.b	Shield(a5)
		beq.s	\no_shield
			clr.b	Shield(a5)
			bra.s	\shield
\no_shield:	tst.w	Ring(a6)
		bne.s	\rings
			move.w	#_INIT_DEAD,Action(a5)
			bra.s	\no_tuch
\rings:		bsr	Init_rings
\shield		move.w	#MAX_CLIGNOTEMENT,C_cpt(a5)
		move.w	#(_OUILLE),Action(a5)
;		clr.b	Alignement(a6)
		move.w	Vx(a5),d0
		bge.s	\dir_inf
			move.w	#(OUILLE_VX),d0
			bra.s	\d_x
\dir_inf:	move.w	#(-OUILLE_VX),d0
\d_x:
		move.w	d0,Vx(a5)
		move.w	d0,V(a5)
		move.l	#(-OUILLE_JUMP),Vy(a5)	; V
\no_tuch:
	clr.b	Force(a5)

	; Test SSonic -> Force
;	tst.w	I_cpt(a5)
;	sne.b	Force(a5)	; Destroying

	; Invulnerability
	move.w	I_cpt(a5),d0
	beq.s	\no_invu
		st.b	Force(a5)
		subq.w	#1,d0
		move.w	d0,I_cpt(a5)
		; Init stars
		move.w	Invu_no(a5),d2
		addq.w	#4,d2
		and.w	#15*4,d2
		move.w	d2,Invu_no(a5)
		move.l	d6,d0
		swap	d0		; D0 = X
		move.w	d6,d1		; D1 = Y
		moveq	#INVU_TMP,d4
		add.w	Invu_table(Pc,d2.w),d0
		add.w	(Invu_table+2)(Pc,d2.w),d1
		moveq	#SPR_STAR,d2
		bsr	Init_sprite
\no_invu:
	; If SSonic
	; Corrige l'animation !

	; Clignotement
	or.b	#%00010000,Type_aff(a5)
	move.w	C_cpt(a5),d0
	beq.s	\okd
	and.w	#1,d0
	beq.s	\okc
		and.b	#%11101111,Type_aff(a5)
\okc:	subq.w	#1,C_cpt(a5)
\okd:	rts

; Table d'indexage en fonction de la diagonale courante
Diag_table:
	dc.w	diag_0-Diag_table
	dc.w	diag_2-Diag_table
	dc.w	diag_4-Diag_table
	dc.w	diag_6-Diag_table
	dc.w	diag_8-Diag_table
	dc.w	diag_10-Diag_table
	dc.w	diag_12-Diag_table
	dc.w	diag_14-Diag_table

; Table d'toiles de l'invulnrabilit !
Invu_table:
	dc.w	000,000
	dc.w	-16,004
	dc.w	-10,008
	dc.w	001,010
	dc.w	009,008
	dc.w	010,004
	dc.w	007,-05
	dc.w	-02,-07
	dc.w	-16,-10
	dc.w	-14,-01
	dc.w	000,005
	dc.w	014,016
	dc.w	017,016
	dc.w	020,008
	dc.w	015,003
	dc.w	008,001

diag_0:
	moveq	#0,d4		; V_flip = 0 / H_flip = 0
	tst.l	V(a5)
	beq.s	\pas_bouge
	bgt.s	\ok
	moveq	#%10,d4		; V_flip = 0 / H_flip = 1
\ok:	rts
\pas_bouge:
	move.b	Type_aff(a5),d4	; Il ne bouge pas : on garde la meme animation
	and.b	#%010,d4
	rts

diag_2:
	moveq	#0,d4		; V_flip = 0 / H_flip = 0
	add.w	#(RF_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	add.w	#(RG_WALK-RF_WALK),d3
\ok:	rts

diag_4:
	moveq	#0,d4		; V_flip = 0 / H_flip = 0
	add.w	#(R_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	moveq	#%100,d4	; V_flip = 1 / H_flip = 0
\ok:	rts

diag_6:
	moveq	#%100,d4	; V_flip = 1 / H_flip = 0
	add.w	#(RG_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	add.w	#(RF_WALK-RG_WALK),d3
\ok:	rts

diag_8:
	moveq	#%100,d4
	tst.l	V(a5)
	blt.s	\ok
	moveq	#%110,d4
\ok:	rts

diag_10:
	moveq	#%110,d4	; V_flip = 1 / H_flip = 1
	add.w	#(RF_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	add.w	#(RG_WALK-RF_WALK),d3
\ok:	rts

diag_12:
	moveq	#%110,d4	; V_flip = 1 / H_flip = 1
	add.w	#(R_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	moveq	#%10,d4		; V_flip = 0 / H_flip = 1
\ok:	rts

diag_14:
	moveq	#%010,d4	; V_flip = 0 / H_flip = 1
	add.w	#(RG_WALK-WALK),d3
	tst.l	V(a5)
	bgt.s	\ok
	add.w	#(RF_WALK-RG_WALK),d3
\ok:	rts


;************************************************************************
; Routines charger de deplacer SONIC d'un maximun de 16 pixels a la fois.
;************************************************************************

move_sonic:
	; Do the main action & update d6.l
	move.l	key(a6),d4
	lea	Action_table(Pc),a0
	move.w	Action(a5),d0
	move.w	0(a0,d0.w),d0
	jsr	0(a0,d0.w)

	; Charge une constante dans d4.l
	moveq	#16,d4

	; If Sonic does his dead jump, we don't test anything !
	cmp.w	#_DEAD,Action(a5)
	beq	_rts

	; Outside the limits of the scrolling ?
	; Test if we need to change the sub-level.
	move.l	d6,d3
	swap	d3		; D3 = X_center

	move.w	xmin(a6),d0
	add.w	#LEFT_LIM,d0
	cmp.w	d3,d0
	ble.s	\ok
		cmp.w	#UP_LIM,d3
		bgt.s	\No1
		tst.b	Sub_lev_x(a6)
		beq.s	\No1
			subq.b	#1,Sub_lev_x(a6)	; Change sub-level
			move.w	xmax(a6),d0
			add.w	#LCD_WIDTH-RIGHT_LIM-1,d0
			move.w	d0,X(a5)
			move.b	#NEXT,Exit(a6)	
			bra	sonic_exe_fin
\No1:		move.w	d0,X(a5)
		clr.l	V(a5)
		bra.s	\ok2

\ok:	move.w	xmax(a6),d0
	add.w	#LCD_WIDTH-RIGHT_LIM,d0
	cmp.w	d3,d0
	bge.s	\ok2
		move.w	Len_x(a6),d1
		lsl.w	#4,d1			; 16 * 2^Sx - 9
		sub.w	#RIGHT_LIM,d1
		cmp.w	d3,d1
		bgt.s	\No2
		move.l	Level_adr(a6),a0
		move.b	MX1(a0),d1
		subq.b	#1,d1
		cmp.b	Sub_lev_x(a6),d1
		beq.s	\No2
			addq.b	#1,Sub_lev_x(a6)
			move.w	#LEFT_LIM+1,X(a5)
			move.b	#NEXT,Exit(a6)
			bra	sonic_exe_fin
\No2:		move.w	d0,X(a5)
		clr.l	V(a5)

\ok2:	move.w	ymin(a6),d0
	add.w	#UP_LIM,d0
	cmp.w	d6,d0
	ble.s	\ok3
		cmp.w	#UP_LIM,d6
		bge.s	\No3
		tst.b	Sub_lev_y(a6)
		beq.s	\No3
			subq.b	#1,Sub_lev_y(a6)
			move.w	ymax(a6),d0
			add.w	#LCD_HEIGHT-DOWN_LIM-1,d0
			move.w	d0,Y(a5)
			move.b	#NEXT,Exit(a6)
			bra	sonic_exe_fin
\No3:		add.w	d4,d0			; d4.w = 16
		move.w	d0,Y(a5)
		bra.s	\ok4

\ok3:	move.w	ymax(a6),d0
	add.w	#LCD_HEIGHT-DOWN_LIM,d0	; Attention : danger !
	cmp.w	d6,d0
	bge.s	\ok4
		move.l	Level_adr(a6),a0
		moveq	#0,d1
		move.b	MY1(a0),d1
		lsl.w	#4,d1
		sub.w	#DOWN_LIM,d1
		cmp.w	d6,d1			; Cmp with Y = d6.W
		bge.s	\No4
		move.l	Level_adr(a6),a0
		move.b	MY1(a0),d1
		subq.b	#1,d1
		cmp.b	Sub_lev_y(a6),d1
		beq.s	\No4
			addq.b	#1,Sub_lev_y(a6)
			move.w	#(UP_LIM+17),Y(a5)
			move.b	#NEXT,Exit(a6)
			bra.s	sonic_exe_fin
\No4:		move.w	#_INIT_DEAD,Action(a5)

\ok4:

	; Reset Pesanteur
	move.l	#PESANTEUR,Pesanteur(a5)
	
	; Test objets
	lea	Object_table(Pc),a3
	move.w	d6,d1		; D1 = Y
	move.l	d6,d0
	swap	d0		; D0 = X

	subq.w	#7,d0
	subq.w	#4,d1
	
	; D0 = x, D1 = y, d2 = offset, D3 = Object-type
	; A3 -> Object table
	moveq	#0,d3
	read_for_test
	lsl.w	#2,d3
	move.w	0(a3,d3.w),d3
	jsr	0(a3,d3.w)	; Execute the object

	add.w	d4,d0		; X += 16
	addq.w	#1,d2		; Next case
	moveq	#0,d3
	move.b	0(a4,d2.w),d3	; Read obj
	lsl.w	#2,d3
	move.w	0(a3,d3.w),d3
	jsr	0(a3,d3.w)	; Execute the object

	add.w	d4,d1		; Y+=16
	add.w	Len_x(a6),d2	; Next case
	moveq	#0,d3
	move.b	0(a4,d2.w),d3
	lsl.w	#2,d3
	move.w	0(a3,d3.w),d3
	jsr	0(a3,d3.w)

	sub.w	d4,d0		; X-=16
	subq.w	#1,d2		; Next case
	moveq	#0,d3
	move.b	0(a4,d2.w),d3
	lsl.w	#2,d3
	move.w	0(a3,d3.w),d3
	jmp	0(a3,d3.w)	; The last one :)

; Breaker : on continue immediatement sans derouler tous les autres appels a move_sonic
sonic_exe_fin:
	move.l	Org_stack(a5),a7
_rts:
	rts

;*********************************************************
; les deux tables d'indirection de l'action de Sonic
;*********************************************************

Action_table:
	dc.w	Walk_a-Action_table		; On marche sur le plancher
	dc.w	Walk_b-Action_table		; On marche sur le mur gauche
	dc.w	Walk_c-Action_table		; On marche sur la plafond
	dc.w	Walk_d-Action_table		; On marche sur le mur droit
	dc.w	Tombe-Action_table		; On tombe ou monte suivant la vitesse + gestion pesanteur
	dc.w	Saute-Action_table		; On saute
	dc.w	Bumper-Action_table		; On bumpe
	dc.w	Ouille-Action_table		; On s'est fait mal
	dc.w	Init_dead-Action_table		; On initialise le saut de la mort
	dc.w	Dead-Action_table		; On fait le saut de la mort (a ne pas init directment !)
	dc.w	calc_a_d6-Action_table		; On accumule de la vitesse
	dc.w	Tube-Action_table		; Les tubes ultra rapides
	dc.w	calc_a_d6-Action_table		; Les plat-forms
	dc.w	Tube_End-Action_table		; Fin des tubes...
	dc.w	Bumper2-Action_table		; Bumper v2...
	dc.w	accro_d6-Action_table		; Accrocher
	dc.w	calc_a_d6-Action_table		; Trap
	dc.w	Vrot-Action_table		; Vrot

Action2_table:
	dc.w	_rts-Action2_table		; On marche sur le plancher
	dc.w	_rts-Action2_table		; On marche sur le mur gauche
	dc.w	_rts-Action2_table		; On marche sur la plafond
	dc.w	_rts-Action2_table		; On marche sur le mur droit
	dc.w	_rts-Action2_table		; On tombe ou monte suivant la vitesse + gestion pesanteur
	dc.w	_rts-Action2_table		; On saute
	dc.w	_rts-Action2_table		; On bumpe
	dc.w	_rts-Action2_table		; On s'est fait mal
	dc.w	_rts-Action2_table		; On initialise le saut de la mort
	dc.w	_rts-Action2_table		; On fait le saut de la mort (a ne pas init directment !)
	dc.w	Speed_Up-Action2_table		; On accumule de la vitesse
	dc.w	_rts-Action2_table		; Les tubes ultra rapides
	dc.w	Plat_form-Action2_table		; Les plat-forms
	dc.w	_rts-Action2_table		; Fin des tubes...
	dc.w	_rts-Action2_table		; Bumper v2...
	dc.w	Accrocher-Action2_table		; Accrocher
	dc.w	Trapeze-Action2_table		; Trapeze
	dc.w	_rts-Action2_table		; V rot


;************************************************************************
; Table d'incrementation de la vitesse en fonction de la vitesse
;************************************************************************
; Comme la vitesse peut etre negative, il faut prevoir aussi avant :)
;	dc.l	0
;	dc.l	65536/8/TURBO/MOVING
;	dc.l	65536/4/TURBO/MOVING
;	dc.l	65536/2/TURBO/MOVING
;	dc.l	65536/TURBO/MOVING
;Inc_Vitesse:
;	dc.l	65536/TURBO/MOVING
;	dc.l	65536/2/TURBO/MOVING
;	dc.l	65536/4/TURBO/MOVING
;	dc.l	65536/8/TURBO/MOVING
;	dc.l	0

	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	65536/4/TURBO/MOVING
	dc.l	65536/2/TURBO/MOVING
Inc_Vitesse:
	dc.l	65536/2/TURBO/MOVING
	dc.l	65536/4/TURBO/MOVING
	dc.l	0
	dc.l	0
	dc.l	0

;************************************************************************
; Marcher sur le sol 
;************************************************************************
Walk_a:
	moveq	#16,d6
	move.w	#WALK,Ani(a5)		; On supose qu'on fait l'ani standart

	; Load adress of speed table
mar_a_calc_speed:
	lea	Case_A_table(Pc),a3

	; Calcul vitesse au point courant ou en-dessous
	move.w	X(a5),d0
	move.w	Y(a5),d1
	moveq	#0,d2
	read_a4
	filtre_surfa.s	pas_de_surface_
	pea	marche_a_hor(Pc)
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jmp	0(a3,d2.w)
pas_de_surface_:
	add.w	d6,d1
	read_a4
	filtre_surfa	pas_de_surface
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jsr	0(a3,d2.w)

	; Deplacement
marche_a_hor:
;	btst.l	#kh_key,d4
;	beq.S	marche_a_hor

	; Lecture des donnes courantes
	move.l	X(a5),d0
	move.w	Y(a5),d1
	add.l	Vx(a5),d0
	move.l	d0,d5
	swap	d0

	; Ajustement  cause de l'adhrence
	addq.w	#1,d1
	tst.l	Vy(a5)
	beq.s	\ok_null
	blt.s	\ok_ca_suffit
	add.w	#15,d1
	bra.s	\ok_ca_suffit
\ok_null:
	addq.w	#7,d1
\ok_ca_suffit:
	bsr	Calcul_surface_A
	cmp.w	d1,d3
	beq	mar_a_tombe
	move.w	d3,d1

	; d4.l = Xnew / d0.w = Xnew / d3.w = Ynew
	sub.w	#16,d1
	tst.l	Vx(a5)
	beq.s	mar_a_done
	bgt.s	marche_a_sup
	or.b	#%10,Type_aff(a5)	; Flip H
	subq.w	#7,d0
	test_mur2.s	<read_destroy_a4>,mar_a_done
mar_a_coince:
	move.l	V(a5),d0
	asr.l	#1,d0
	move.l	d0,V(a5)
	move.w #POUSSE,Ani(a5)
	bra.s	mar_a_end1
marche_a_sup:
	and.b	#%11111100,Type_aff(a5)	; No flip
	addq.w	#7,d0
	test_mur.s	<read_destroy_a4>,mar_a_coince
mar_a_done:
	move.l	d5,X(a5)
	move.w	d3,Y(a5)
mar_a_end1:

; Determine l'animation courante
mar_a_fin:
	move.w	Ani(a5),d3
	and.b	#%11111010,Type_aff(a5)

	tst.l	V(a5)
	bne.s	\move0
		; Vitesse nulle / Determine animation : Haut / Bas/ Equili / debout / attente
		clr.b	Boule(a5)
		btst.l	#up_key,d4
		bne.s	\no_up
			moveq	#HAUT,d3
			bra.s	\move1
\no_up:		moveq	#0,d5
		move.w	X(a5),d0
		subq.w	#8,d0
		move.w	Y(a5),d1
		addq.w	#2,d1
		read_destroy_a4
		filtre_surfa.s	\no_surf
			addq.w	#1,d5
\no_surf:	addq.w	#1,d0
		move.b	0(a4,d0.w),d2
		filtre_surfa.s	\no_surf2
			addq.w	#1,d5
\no_surf2:	subq.w	#1,d5
		bne.s	\no_equili
			moveq	#EQUILI,d3
			bra.s	\move1		
\no_equili:	moveq	#DEBOUT,d3
		addq.w	#1,W_cpt(a5)
		cmp.w	#MAX_WAIT,W_cpt(a5)
		bls.s	\move1
			moveq	#WAIT,d3
			bra.s	\move1
\move0:
	clr.w	W_cpt(a5)
\move1:
	btst.l	#down_key,d4
	bne.s	\no_down
		cmp.w	#BOULE_LIMIT,Abs_v(a5)
		bhi.s	\do_boule
			moveq	#BAS,d3
			btst.l	#Jump_key,d4
			beq.s	init_speed_up
			clr.b	Boule(a5)
			clr.l	V(a5)
			bra.s	\no_down
\do_boule:
		st	Boule(a5)
\no_down:
	move.w	d3,Ani(a5)

	; Teste le saut...
	btst.l	#Jump_key,d4
	bne.s	mar_a_no_jump
mar_a_jump:
		st.b	Boule(a5)
		move.l	Jx(a5),d0
		add.l	d0,Vx(a5)
		move.l	Jy(a5),d0
		add.l	d0,Vy(a5)
		move.w	#STD_JUMP_CPT,J_cpt(a5)
		move.w	#_SAUTE,Action(a5)
		bra	Saute
mar_a_no_jump:

	; Calcul de d6 = coordonnes du perso pour les SR
calc_a_d6:
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts

mar_a_tombe:
	btst.l	#Jump_key,d4
	beq.s	mar_a_jump
	move.w	#_TOMBE,Action(a5)
	bra	Tombe

init_speed_up:
	move.w #_SPEED_UP,Action(a5)
	move.w	d3,Ani(a5)
	moveq	#STD_SPEED_UP,d0
	btst.b	#Type_aff_H,Type_aff(a5)
	beq.s	\sup
	neg.w	d0
\sup:	move.w	d0,V(a5)
	bra.s	calc_a_d6

Case_A_table:
	dc.w	CaseRien-Case_A_table
	dc.w	CaseA1-Case_A_table
	dc.w	CaseA3-Case_A_table
	dc.w	CaseA4-Case_A_table
	dc.w	CaseA5-Case_A_table
	dc.w	CaseA6-Case_A_table
	dc.w	CaseA7-Case_A_table
	dc.w	CaseA8-Case_A_table
	dc.w	CaseA9-Case_A_table
	dc.w	CaseA10-Case_A_table
	dc.w	CaseA11-Case_A_table
	dc.w	CaseA12-Case_A_table
	dc.w	CaseA13-Case_A_table
	dc.w	CaseA14-Case_A_table
	dc.w	CaseA21-Case_A_table
	dc.w	CaseA26-Case_A_table

CaseRien:
	rts

; Comportement bloc
CaseA1:
CaseA2:
CaseA21:
CaseA26:
	;calcul_vitesse_long <boule_macro>,<left_walk_macro>,<right_walk_macro>,<nokey_macro>
	lea	case1_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	clr.l	Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
	;clr.w	Diag(a5)
	rts

CaseA14:
;	calcul_vitesse_medium.s <Dec_boule_macro>,<left_walk_macro>,<right_walk_macro>,<DEC_v_macro>
	lea	case1_floor(Pc),a0
	bsr	accelerate
	cmp.l	#(SPEED_A4_LIMIT),d2
	blt.s	\normal
	move.w	#_WALK_B,Action(a5)
	clr.l	Vx(a5)
	neg.l	d2
	move.l	d2,Vy(a5)
	move.l	#(-JUMP_Y*7/10),d0
	move.l	d0,Jx(a5)
	move.l	d0,Jy(a5)
	addq.l	#4,a7
	bra	Walk_b
\normal:
	move.l	Vy(a5),d0
	ble.s	\ok
	sub.l	d0,d2
\ok:	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	move.l	#(-JUMP_Y*7/10),d0
	move.l	d0,Jx(a5)
	move.l	d0,Jy(a5)
;	clr.w	Diag(a5)
	rts

	
CaseA8:
;	calcul_vitesse_medium.s <Inc_boule_macro>,<left_walk_macro>,<right_walk_macro>,<INC_v_macro>
	lea	case1_floor(Pc),a0
	bsr	accelerate
	cmp.l	#(SPEED_A7_LIMIT),d2
	bgt.s	\normal
	move.w	#_WALK_D,Action(a5)
	clr.l	Vx(a5)
	move.l	d2,Vy(a5)
	move.l	#(-JUMP_Y*7/10),d0
	move.l	d0,Jx(a5)
	move.l	d0,Jy(a5)
	addq.l	#4,a7
	bra	Walk_d
\normal:
	move.l	Vy(a5),d0
	ble.s	\ok
	add.l	d0,d2
\ok:	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	move.l	#(-JUMP_Y*7/10),d0
	move.l	d0,Jx(a5)
	move.l	d0,Jy(a5)
;	clr.w	Diag(a5)
	rts

CaseA10:
CaseA9:
;	calcul_vitesse_medium.s <dec_boule_macro>,<left_walk_macro>,<right_walk_macro>,<dec_v_macro>
	lea	case2_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vy(a5)
	clr.l	Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
;	clr.w	Diag(a5)
	rts
	
CaseA6:
CaseA7:
;	calcul_vitesse_medium.s <inc_boule_macro>,<left_walk_macro>,<right_walk_macro>,<inc_v_macro>
	lea	case16_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	move.l	d2,Vy(a5)
	clr.l	Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
;	clr.w	Diag(a5)
	rts

CaseA12:
CaseA13:
;	move.w	#2,Diag(a5)
;	calcul_vitesse_medium.s <DEC_boule_macro>,<left_walk_macro>,<right_walk_macro>,<DEC_v_macro>
	lea	case4_floor(Pc),a0
	bsr	accelerate
	move.l	#(-(3*JUMP_Y/4)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.l	d2,d1
	neg.l	d2
	move.l	d2,Vy(a5)
	asr.l	#1,d1
	move.l	d1,Vx(a5)
	cmp.w	#ADERENCE_LIMIT,V(a5)
	ble.s	\end
	move.w	#_WALK_B,Action(a5)
	addq.l	#4,a7
	bra.s	Walk_b
\end:	rts

CaseA3:
CaseA4:
;	move.w	#14,Diag(a5)
;	calcul_vitesse_medium.s <INC_boule_macro>,<left_walk_macro>,<right_walk_macro>,<INC_v_macro>
	lea	case14_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	move.l	d2,Vx(a5)
	move.l	#((3*JUMP_Y/4)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	cmp.w	#-ADERENCE_LIMIT,V(a5)
	bge.s	\end
	move.w	#_WALK_D,Action(a5)
	addq.l	#4,a7
	bra	Walk_d
\end:	rts

CaseA11:
;	calcul_vitesse_medium.s <Dec_boule_macro>,<left_walk_macro>,<right_walk_macro>,<Dec_v_macro>
	lea	case3_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	neg.l	d2
	move.l	d2,Vy(a5)
	clr.l	Jx(a5)
	move.l	#(-4*JUMP_Y/5),Jy(a5)
;	move.w	#2,Diag(a5)
	rts

CaseA5:
;	calcul_vitesse_medium.s <Inc_boule_macro>,<left_walk_macro>,<right_walk_macro>,<Inc_v_macro>
	lea	case15_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	move.l	d2,Vy(a5)
	clr.l	Jx(a5)
	move.l	#(-4*JUMP_Y/5),Jy(a5)
;	move.w	#14,Diag(a5)
	rts








;************************************************************************
; Marcher sur le mur gauche
;************************************************************************
Walk_b:
	; Si vitesse trop lente, tombe
	cmp.w	#ADERENCE_LIMIT,Abs_v(a5)
	bls	mar_b_tombe

	; d6 = 16 pour add
	moveq	#16,d6

	; Load adress of speed table
mar_b_calc_speed:
	lea	Case_B_table(Pc),a3

	; Calcul de la vitesse au point courant
	move.w	X(a5),d0
	move.w	Y(a5),d1
	moveq	#0,d2
	read_a4
;	tst.b	d2
	filtre_surfb.s	pas_de_surface_b
	pea	marche_b_hor(Pc)
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jmp	0(a3,d2.w)
pas_de_surface_b:
	add.w	d6,d0
	read_a4
;	tst.b	d2
	filtre_surfb	mar_b_tombe
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jsr	0(a3,d2.w)

	; Deplacement
marche_b_hor:
	move.w	X(a5),d0
	move.l	Y(a5),d1
	move.l	Vy(a5),d2
	beq.s	mar_b_end1
	bgt.s	marche_b_sup
	sub.l	d2,d1
	move.l	d1,d3
	swap	d1
;	addq.w	#7,d1
	test_mur2.s	<read_destroy_a4>,mar_b_done
mar_b_coince:
	subq.w	#1,d0		; Case (X - 16, Y)
	move.b	0(a4,d0.w),d2	; a0 <-> a4
	cmp.b	Plan_mur(a6),d2
	beq.s	mar_b_coince2
	subq.b	#1,d2
	beq.s	mar_b_coince2
	sub.w	d6,X(a5)	; X - 16
	bra.s	mar_b_done
mar_b_coince2:
	move.l	V(a5),d0
	asr.l	#1,d0
	move.l	d0,V(a5)
	bra.s	mar_b_end1
marche_b_sup:
	and.b	#%11111000,Type_aff(a5)	; No V flip
	sub.l	d2,d1
	move.l	d1,d3
	swap	d1
;	subq.w	#7,d1
	test_mur.s	<read_destroy_a4>,mar_b_coince
mar_b_done:
	move.l	d3,Y(a5)
mar_b_end1:

	; Lecture des donnes courantes
	move.w	X(a5),d0
	move.w	Y(a5),d1
	
	; Ajustement  cause de l'adhrence
	; Test surface en (X-16,Y) -> (X, Y) -> (X + 16, Y)
mar_b_calcul_surface:
	moveq	#0,d2
	move.w	d1,d3		; d3 = y

	sub.w	d6,d0		; X - 16
	move.w	d0,-(a7)
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.b	0(a4,d1.w),d2
	move.w	(a7)+,d0
;	tst.b	d2
	filtre_surfb.s	mar_b_no_surface_b
	bra.s	mar_b_surfok
mar_b_no_surface_b:
	add.w	d6,d0
	addq.w	#1,d1		; Case (X, Y)
	move.b	0(a4,d1.w),d2	; a4 <-> a0
	filtre_surfb.s	mar_b_no_surf2
	bra.s	mar_b_surfok
mar_b_no_surf2:
	add.w	d6,d0
	addq.w	#1,d1		; Case (X + 16, Y)
	move.b	0(a4,d1.w),d2	; a4 Test adr
	filtre_surfb	mar_b_tombe
mar_b_surfok:
	lea	Surface_B_table(Pc),a0
	lsl.w	#5,d2		; A surface is 32 bytes long
	and.w	#15,d3		; d3 = y % 16
	add.w	d3,d3
	add.w	d3,d2		; d2 = offset
	and.w	#(-15-1),d0
	add.w	0(a0,d2.w),d0	; d0 = (X and $FFF0) + Sur_B(y % 16)
	move.w	d0,X(a5)
mar_b_end2:

	; Determine l'animation courante
	btst.l	#down_key,d4
	bne.s	\no_down
	st	Boule(a5)
\no_down:
	move.w	#WALK,Ani(a5)

	; Teste le saut...
	btst.l	#Jump_key,d4
	bne.s	\no_jump
	st.b	Boule(a5)
	subq.w	#8,X(a5)
	add.w	#16,Y(a5)
	neg.l	Vy(a5)
	neg.l	V(a5)
	move.l	Jx(a5),d0
	add.l	d0,Vx(a5)
	move.l	Jy(a5),d0
	add.l	d0,Vy(a5)
	move.w	#STD_JUMP_CPT,J_cpt(a5)
	move.w	#_SAUTE,Action(a5)
	bra	Saute
\no_jump:
	
	; Calcul de D6
	move.w	X(a5),d6
	sub.w	#16,d6
	swap	d6
	move.w	Y(a5),d6
	rts

mar_b_tombe:
	move.w	#_TOMBE,Action(a5)
	move.l	V(a5),d0
	neg.l	d0
	move.l	d0,Vy(a5)
	clr.l	V(a5)
	subq.w	#8,X(a5)
	add.w	#16,Y(a5)
	bra	Tombe

Case_B_table:
	dc.w	CaseRien-Case_B_table
	dc.w	CaseB1-Case_B_table
	dc.w	CaseB8-Case_B_table
	dc.w	CaseB9-Case_B_table
	dc.w	CaseB10-Case_B_table
	dc.w	CaseB11-Case_B_table
	dc.w	CaseB12-Case_B_table
	dc.w	CaseB13-Case_B_table
	dc.w	CaseB14-Case_B_table
	dc.w	CaseB15-Case_B_table
	dc.w	CaseB16-Case_B_table
	dc.w	CaseB17-Case_B_table
	dc.w	CaseB18-Case_B_table
	dc.w	CaseB19-Case_B_table
	dc.w	CaseB20-Case_B_table
	dc.w	CaseB26-Case_B_table

; Comportement Bloc

CaseB1:
CaseB8:
CaseB26:
;	move.w	#4,Diag(a5)
;	calcul_vitesse <DEC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case5_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(-JUMP_Y),Jx(a5)
	rts

CaseB14:
;	move.w	#4,Diag(a5)
;	calcul_vitesse.s <DEC_v_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case5_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	bgt.s	\no
	move.w	#_WALK_A,Action(a5)
	clr.l	Vy(a5)
	addq.l	#4,a7
	bra	Walk_a
\no:
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(-JUMP_Y),Jx(a5)
	rts

CaseB20:
;	move.w	#4,Diag(a5)
;	calcul_vitesse.s <DEC_v_macro>,<left_walk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case5_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	blt.s	\no
	move.w	#_WALK_C,Action(a5)
	clr.l	Vy(a5)
	addq.l	#4,a7
	bra	Walk_c
\no:
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(-JUMP_Y),Jx(a5)
	rts

CaseB9:
CaseB10:
	lea	case2_floor(Pc),a0
	bsr	accelerate
;	move.w	#2,Diag(a5)
;	calcul_vitesse.s <dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<dec_v_macro>
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	move.l	d2,Vy(a5)
	move.l	#(-(JUMP_Y/4)),Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
	move.w	#_WALK_A,Action(a5)
	addq.l	#4,a7
	bra	Walk_a
	
CaseB18:
CaseB19:
;	move.w	#6,Diag(a5)
;	calcul_vitesse.s <dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<dec_v_macro>
	lea	case8_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/4)),Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
	move.w	#_WALK_C,Action(a5)
	addq.l	#4,a7
	bra	Walk_c

CaseB12:
CaseB13:
;	move.w	#4,Diag(a5)
;	calcul_vitesse.s <DEC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case4_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	move.l	d2,Vx(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/4),Jy(a5)
	rts

CaseB15:
CaseB16:
;	move.w	#4,Diag(a5)
;	calcul_vitesse.s <DEC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case6_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vx(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/4),Jy(a5)
	rts

CaseB11
;	move.w	#2,Diag(a5)
;	calcul_vitesse.s <dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Dec_v_macro>
	lea	case3_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	neg.l	d2
	move.l	d2,Vx(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_A,Action(a5)
;	rts
	addq.l	#4,a7
	bra	Walk_a

CaseB17:
;	move.w	#6,Diag(a5)
;	calcul_vitesse.s <dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Dec_v_macro>
	lea	case7_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_C,Action(a5)
;	rts
	addq.l	#4,a7
	bra	Walk_c





;************************************************************************
; Marcher sur le plafond
;************************************************************************
Walk_c:
	; Adhrence
	cmp.w	#ADERENCE_LIMIT,Abs_v(a5)
	bls	mar_c_tombe

	; d6 = 16 pour add
	moveq	#16,d6

mar_c_calc_speed:
	; Load adress of speed table
	lea	Case_C_table(Pc),a3

	; Calcul de la vitesse au point courant
	move.w	X(a5),d0
	move.w	Y(a5),d1
	moveq	#0,d2
	read_a4
;	tst.b	d2
	filtre_surfc.s	pas_de_surface_c
	pea	marche_c_hor(Pc)
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jmp	0(a3,d2.w)
pas_de_surface_c:
	sub.w	d6,d1
	read_a4
;	tst.b	d2
	filtre_surfc	mar_c_tombe
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jsr	0(a3,d2.w)

	; Deplacement horizontal
marche_c_hor:
	move.l	X(a5),d0
	move.w	Y(a5),d1
	move.l	Vx(a5),d2
	beq.s	mar_c_end1
	bgt.s	marche_c_sup
	sub.l	d2,d0
	move.l	d0,d3
	swap	d0
;	addq.w	#7,d0
	test_mur2.s	<read_destroy_a4>,mar_c_done
mar_c_coince:
	add.w	Len_x(a6),d0		; Case (X, Y + 16)
	move.b	0(a4,d0.w),d2	; a0 <-> a4
	cmp.b	Plan_mur(a6),d2
	beq.s	mar_c_coince2
	subq.b	#1,d2
	beq.s	mar_c_coince2
	add.w	d6,Y(a5)	; Y + 16
	bra.s	mar_c_done
mar_c_coince2:
	move.l	V(a5),d0
	asr.l	#1,d0
	move.l	d0,V(a5)
	bra.s	mar_c_end1
marche_c_sup:
	or.b	#%010,Type_aff(a5)	; Hor flip
	sub.l	d2,d0
	move.l	d0,d3
	swap	d0
;	subq.w	#7,d0
	test_mur.s	<read_destroy_a4>,mar_c_coince
mar_c_done:
	move.l	d3,X(a5)
mar_c_end1:

	; Lecture des donnes courantes
	move.w	X(a5),d0
	move.w	Y(a5),d1
	
	; Ajustement  cause de l'adhrence
	; Test surface en (X, Y+16) -> (X, Y) -> (X, Y-16)

mar_c_calcul_surface:
	add.w	d6,d1		; Y + 16
	moveq	#0,d2
	move.w	d0,d3		; d3 = x 
	move.w	d1,-(a7)
	read_destroy_a4
	move.w	(a7)+,d1
;	tst.b	d2
	filtre_surfc.s	mar_c_no_surface_c
	bra.s	mar_c_surfok
mar_c_no_surface_c:
	sub.w	d6,d1
	sub.w	Len_x(a6),d0		; Case (X, Y)
	move.b	0(a4,d0.w),d2	; a4 <-> a0
	filtre_surfc.s	mar_c_no_surfc
	bra.s	mar_c_surfok
mar_c_no_surfc:
	sub.w	d6,d1
	sub.w	Len_x(a6),d0		; Case (X, Y-16)
	move.b	0(a4,d0.w),d2		; a4 = Test_adr
	filtre_surfc	mar_c_tombe
mar_c_surfok:
	lea	Surface_C_table(Pc),a0
	lsl.w	#5,d2		; A surface is 32 bytes long
	and.w	#15,d3		; d3 = x % 16
	add.w	d3,d3
	add.w	d3,d2		; d2 = offset
	and.w	#(-15-1),d1
	add.w	0(a0,d2.w),d1	; d1 = (Y and $FFF0) + Sur_A(x % 16)
	move.w	d1,Y(a5)
mar_c_end2:

	; Determine l'animation courante
	move.w	#WALK,Ani(a5)

	btst.l	#down_key,d4
	bne.s	\no_down
	st	Boule(a5)
\no_down:

	; Teste le saut...
	btst.l	#Jump_key,d4
	bne.s	\no_jump
	st.b	Boule(a5)
	add.w	#32,Y(a5)
	neg.l	V(a5)
	neg.l	Vx(a5)
	move.l	Jx(a5),d0
	add.l	d0,Vx(a5)
	move.l	Jy(a5),d0
	add.l	d0,Vy(a5)
	move.w	#STD_JUMP_CPT,J_cpt(a5)
	move.w	#_SAUTE,Action(a5)
	bra	Saute
\no_jump:
	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.W	Y(a5),d6
	add.w	#16,d6
	rts

mar_c_tombe:
	move.w	#_TOMBE,Action(a5)
	neg.l	V(a5)
	neg.l	Vx(a5)
	add.w	#32,Y(a5)
	bra	Tombe

Case_C_table:
	dc.w	CaseRien-Case_C_table
	dc.w	CaseC1-Case_C_table
	dc.w	CaseC8-Case_C_table
	dc.w	CaseC14-Case_C_table
	dc.w	CaseC15-Case_C_table
	dc.w	CaseC16-Case_C_table
	dc.w	CaseC17-Case_C_table
	dc.w	CaseC18-Case_C_table
	dc.w	CaseC19-Case_C_table
	dc.w	CaseC20-Case_C_table
	dc.w	CaseC21-Case_C_table
	dc.w	CaseC22-Case_C_table
	dc.w	CaseC23-Case_C_table
	dc.w	CaseC24-Case_C_table
	dc.w	CaseC25-Case_C_table
	dc.w	CaseC26-Case_C_table

; Comportement bloc
CaseC1:
CaseC8:
CaseC14:
;	move.w	#8,Diag(a5)
;	calcul_vitesse <boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<nokey_macro>
	lea	case9_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	clr.l	Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	rts

CaseC20:
;	move.w	#8,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case9_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	bgt.s	\no
	move.w	#_WALK_B,Action(a5)
	clr.l	Vx(a5)
	addq.l	#4,a7
	bra	Walk_b
\no:
	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	clr.l	Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	rts
	
CaseC26:
;	move.w	#8,Diag(a5)
;	calcul_vitesse.s <Dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case9_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	ble.s	\no
	move.w	#_WALK_D,Action(a5)
	clr.l	Vx(a5)
	addq.l	#4,a7
	bra	Walk_d
\no:
	move.l	d2,Vx(a5)
	clr.l	Vy(a5)
	clr.l	Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	rts

CaseC21:
CaseC22:
;	move.w	#8,Diag(a5)
;	calcul_vitesse.s <inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<inc_v_macro>
	lea	case10_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	move.l	d2,Vy(a5)
	move.l	#(-(JUMP_Y/4)),Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	rts
	
CaseC18:
CaseC19:
;	move.w	#8,Diag(a5)
;	calcul_vitesse.s <dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<dec_v_macro>
	lea	case8_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/4)),Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	rts

CaseC24:
CaseC25:
;	move.w	#10,Diag(a5)
;	calcul_vitesse.s <INC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case12_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	move.l	d2,Vx(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_D,Action(a5)
	addq.l	#4,a7
	bra.s	Walk_d

CaseC15:
CaseC16:
;	move.w	#6,Diag(a5)
;	calcul_vitesse.s <DEC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<DEC_v_macro>
	lea	case6_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vx(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_B,Action(a5)
	addq.l	#4,a7
	bra	Walk_b

CaseC23:
;	move.w	#10,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Inc_v_macro>
	lea	case11_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	move.l	d2,Vy(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(JUMP_Y/2),Jy(a5)
	rts

CaseC17:
;	move.w	#6,Diag(a5)
;	calcul_vitesse.s <Dec_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Dec_v_macro>
	lea	case7_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	neg.l	d2
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(JUMP_Y/2),Jy(a5)
	rts


;************************************************************************
; Marcher sur le mur droit
;************************************************************************
Walk_d:
	; Si vitesse trop lente, tomb
	cmp.w	#ADERENCE_LIMIT,Abs_v(a5)
	bls	mar_d_tombe

	; d6 = 16 pour add
	moveq	#16,d6

mar_d_calc_speed:
	; Load adress of speed table
	lea	Case_D_table(Pc),a3

	; Calcul de la vitesse au point courant
	move.w	X(a5),d0
	move.w	Y(a5),d1
	moveq	#0,d2
	read_a4
;	tst.b	d2
	filtre_surfd.s	pas_de_surface_d
	pea	marche_d_hor(Pc)
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jmp	0(a3,d2.w)
pas_de_surface_d:
	sub.w	d6,d0
	read_a4
;	tst.b	d2
	filtre_surfd	mar_d_tombe
	add.w	d2,d2
	move.w	0(a3,d2.w),d2
	jsr	0(a3,d2.w)

	; Deplacement horizontal
marche_d_hor:
	move.w	X(a5),d0
	move.l	Y(a5),d1
	move.l	Vy(a5),d2
	beq.s	mar_d_end1
	bgt.s	marche_d_sup
	add.l	d2,d1
	move.l	d1,d3
	swap	d1
;	subq.w	#7,d1
	test_mur2.s	<read_destroy_a4>,mar_d_done
mar_d_coince:
	addq.w	#1,d0		; Case (X + 16, Y)
	move.b	0(a4,d0.w),d2	; a0 <-> a4
	cmp.b	Plan_mur(a6),d2
	beq.s	mar_d_coince2
	subq.b	#1,d2
	beq.s	mar_d_coince2
	add.w	d6,X(a5)	; X + 16
	bra.s	mar_d_done
mar_d_coince2:
	move.l	V(a5),d0
	asr.l	#1,d0
	move.l	d0,V(a5)
	bra.s	mar_d_end1
marche_d_sup:
	or.b	#%0100,Type_aff(a5)	; Ver flip
	add.l	d2,d1
	move.l	d1,d3
	swap	d1
;	addq.w	#7,d1
	test_mur.s	<read_destroy_a4>,mar_d_coince
mar_d_done:
	move.l	d3,Y(a5)
mar_d_end1:

	; Lecture des donnes courantes
	move.w	X(a5),d0
	move.w	Y(a5),d1
	
	; Ajustement  cause de l'adhrence
	; Test surface en (X+16,Y) -> (X, Y) -> (X - 16, Y)

mar_d_calcul_surface:
	moveq	#0,d2		; A cause du lsl.w
	add.w	d6,d0		; X + 16
	move.w	d1,d3		; d3 = y
	move.w	d0,-(a7)
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.b	0(a4,d1.w),d2
	move.w	(a7)+,d0
;	tst.b	d2
	filtre_surfd.s	mar_d_no_surface_d
	bra.s	mar_d_surfok
mar_d_no_surface_d:
	sub.w	d6,d0		; X-16
	subq.w	#1,d1		; Case (X, Y)
	move.b	0(a4,d1.w),d2	; a4 <-> a0
	filtre_surfd.s	mar_d_no_surfd
	bra.s	mar_d_surfok
mar_d_no_surfd:
	sub.w	d6,d0
	subq.w	#1,d1		; Case (X -16, Y)
	move.b	0(a4,d1.w),d2	; a4 <-> a0
	filtre_surfd	mar_d_tombe
mar_d_surfok:
	lea	Surface_D_table(Pc),a0
	lsl.w	#5,d2		; A surface is 32 bytes long
	and.w	#15,d3		; d3 = y % 16
	add.w	d3,d3
	add.w	d3,d2		; d2 = offset
	and.w	#(-15-1),d0
	add.w	0(a0,d2.w),d0	; d1 = (Y and $FFF0) + Sur_A(x % 16)
	move.w	d0,X(a5)
mar_d_end2:

	; Determine l'animation courante
	move.w	#WALK,Ani(a5)
	btst.l	#down_key,d4
	bne.s	\no_down
	st	Boule(a5)
\no_down:

	; Teste le saut...
	btst.l	#Jump_key,d4
	bne.s	\no_jump
	st.b	Boule(a5)
	add.w	#8,X(a5)
	add.w	#16,Y(a5)
	move.l	Jx(a5),d0
	add.l	d0,Vx(a5)
	move.l	Jy(a5),d0
	add.l	d0,Vy(a5)
	move.w	#STD_JUMP_CPT,J_cpt(a5)
	move.w	#_SAUTE,Action(a5)
	bra	Saute
\no_jump:
	
	; Calcul de d6
	move.w	X(a5),d6
	add.w	#16,d6
	swap	d6
	move.w	Y(a5),d6
	rts
mar_d_tombe:
	move.w	#_TOMBE,Action(a5)
	move.l	V(a5),Vy(a5)
	clr.l	V(a5)
	add.w	#8,X(a5)
	add.w	#16,Y(a5)
	bra	Tombe

Case_D_table:
	dc.w	CaseRien-Case_D_table
	dc.w	CaseD1-Case_D_table
	dc.w	CaseD3-Case_D_table
	dc.w	CaseD4-Case_D_table
	dc.w	CaseD5-Case_D_table
	dc.w	CaseD6-Case_D_table
	dc.w	CaseD7-Case_D_table
	dc.w	CaseD8-Case_D_table
	dc.w	CaseD14-Case_D_table
	dc.w	CaseD20-Case_D_table
	dc.w	CaseD21-Case_D_table
	dc.w	CaseD22-Case_D_table
	dc.w	CaseD23-Case_D_table
	dc.w	CaseD24-Case_D_table
	dc.w	CaseD25-Case_D_table
	dc.w	CaseD26-Case_D_table

; Comportement bloc
CaseD1:
CaseD14:
CaseD20:
;	move.w	#12,Diag(a5)
;	calcul_vitesse <INC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case13_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(JUMP_Y),Jx(a5)
	rts

CaseD26:
;	move.w	#12,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case13_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	bgt.s	\no
	move.w	#_WALK_C,Action(a5)
	clr.l	Vy(a5)
	addq.l	#4,a7
	bra	Walk_c
\no:
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(JUMP_Y),Jx(a5)
	rts

CaseD8:
;	move.w	#12,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case13_floor(Pc),a0
	bsr	accelerate
	tst.l	d2
	ble.s	\no
	move.w	#_WALK_A,Action(a5)
	clr.l	Vy(a5)
	addq.l	#4,a7
	bra	Walk_a
\no:
	move.l	d2,Vy(a5)
	clr.l	Vx(a5)
	clr.l	Jy(a5)
	move.l	#(JUMP_Y),Jx(a5)
	rts

CaseD21:
CaseD22:
;	move.w	#10,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Inc_v_macro>
	lea	case10_floor(Pc),a0
	bsr	accelerate
	move.l	d2,d1
	neg.l	d1
	move.l	d1,Vx(a5)
	asr.l	#1,d2
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/4)),Jx(a5)
	move.l	#(JUMP_Y),Jy(a5)
	move.w	#_WALK_C,Action(a5)
	addq.l	#4,a7
	bra	Walk_c
	
CaseD6:
CaseD7:
;	move.w	#14,Diag(a5)
;	calcul_vitesse.s <inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<Inc_v_macro>
	lea	case16_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	asr.l	#1,d2
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/4)),Jx(a5)
	move.l	#(-JUMP_Y),Jy(a5)
	move.w	#_WALK_A,Action(a5)
	addq.l	#4,a7
	bra	Walk_a

CaseD24:
CaseD25:
;	move.w	#12,Diag(a5)
;	calcul_vitesse.s <Inc_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case12_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	neg.l	d2
	move.l	d2,Vx(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/4),Jy(a5)
	rts

CaseD3:
CaseD4:
;	move.w	#12,Diag(a5)
;	calcul_vitesse.s <INC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case14_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	asr.l	#1,d2
	move.l	d2,Vx(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/4),Jy(a5)
	rts

CaseD23:
;	move.w	#10,Diag(a5)
;	calcul_vitesse.s <INC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case11_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vy(a5)
	neg.l	d2
	move.l	d2,Vx(a5)
	move.l	#(-(JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_C,Action(a5)
	addq.l	#4,a7
	bra	Walk_c
;	rts

CaseD5:
;	move.w	#14,Diag(a5)
;	calcul_vitesse.s <INC_boule_macro>,<left_wlk_macro>,<right_wlk_macro>,<INC_v_macro>
	lea	case15_floor(Pc),a0
	bsr	accelerate
	move.l	d2,Vx(a5)
	move.l	d2,Vy(a5)
	move.l	#((JUMP_Y/2)),Jx(a5)
	move.l	#(-JUMP_Y/2),Jy(a5)
	move.w	#_WALK_A,Action(a5)
	addq.l	#4,a7
	bra	Walk_a









pas_de_surface:
	move.w	#(_TOMBE),Action(a5)
	bra.s	Tombe

;************************************************************************
; Fin des tubes
;************************************************************************
Tube_End:
	move.w	#_TOMBE,Action(a5)
	move.w	#4,C_cpt(a5)		; Petit clignotement  la sortie... bidouille ;)
	move.l	Vx(a5),d0
	move.l	Vy(a5),d1
	asr.l	#1,d0
	asr.l	#1,d1
	move.l	d0,Vx(a5)
	move.l	d0,V(a5)
	move.l	d1,Vy(a5)
	add.l	d0,X(a5)		; Dernier poussage
	add.l	d1,Y(a5)
	bra.s	Tombe

;************************************************************************
; Saute
;************************************************************************
Saute:
	subq.w	#1,J_cpt(a5)
	bne.s	Tombe
	move.w	#_TOMBE,Action(a5)
	btst.l	#Jump_key,d4
	bne.s	Tombe
	move.l	Jx(a5),d0
	asr.l	#1,d0
	add.l	d0,Vx(a5)
	move.l	Jy(a5),d0
	asr.l	#1,d0
	add.l	d0,Vy(a5)
	bset.b	#(Jump_key-8),(key_mask+2)(a6)

;************************************************************************
; Tombe (ou monte), bref se laisse aller par sa vitesse
;************************************************************************
Tombe:
	; Calcul vitesse
	calcul_vitesse2 <left_fall_macro>,<right_fall_macro>

	; Determine l'animation
	move.w	#WALK,Ani(a5)
	move.w	Diag(a5),d0
	beq.s	\suite
		move.l	d7,d1
		swap	d1
		and.w	#%111,d1
		bne.s	\suite
			subq.w	#2,d0
			cmp.w	#6,d0
			blt.s	\fin
				addq.w	#4,d0
\fin:			and.w	#7*2,d0
			move.w	d0,Diag(a5)	
\suite:

Tombe_in:
	; Vx = V
	move.l	d2,Vx(a5)

	; Test collision mur X
	move.l	X(a5),d0
	move.w	Y(a5),d1
	sub.w	#15,d1
	add.l	d2,d0		; d2 = V=Vx
	move.l	d0,d3		; D3 : save X
	swap	d0		; Fixed to integer
	tst.l	d2	
	beq.s	\no_murx	; On se deplace pas
	blt.s	\inf
	addq.w	#8,d0
	bra.s	\Test
\inf:	subq.w	#8,d0
\Test:	test_mur.b <read_a4>,\if_murx
	move.l	d3,X(a5)	; Ok, on peut y aller !
	bra.s	\no_murx
\if_murx:	; Si mur, on diminie la vitesse de facon logarithmique
	move.l	V(a5),d2
	asr.l	#1,d2
	move.l	d2,V(a5)
\no_murx:

	; Test collision Y
	move.w	X(a5),d0
	move.l	Y(a5),d1

	; Vy += Pesanteur
	move.l	Vy(a5),d6
	cmp.l	#MAX_F_SPEED-ONE,d6
	bgt.s	\no
		add.l	Pesanteur(a5),d6
		move.l	d6,Vy(a5)
\no
	; Determine dans quel sens on tombe: vers le haut ou le bas ?
	blt.s	tombe_inf2	; On tombe vers le haut (On monte)

		; Modification des coordonnes.
		add.l	d6,d1		; d6 = Vy
		move.l	d1,Y(a5)	; Ce sera de toute facon (?) corriger si cce n'est pas le cas
		swap	d1		; Fixed to integer
		swap	d6		; " pour la vitesse

		; Test de collision plancher
		bsr	Calcul_surface_A
		cmp.w	d1,d3	
		beq.s	tombe_EnD	; Hauteur de la cellule insuffisante

			move.w	#_WALK_A,Action(a5)	; On va marcher Marcher
			clr.w	Diag(a5)	; Pas de diagonale :)
			clr.b	Boule(a5)
			move.w	d3,Y(a5)	; Correction de Y
			; Determine vitesse
			bsr	calculate_speed
			move.l	Vx(a5),V(a5)
			bra.s	tombe_EnD

; On monte
tombe_inf2:
	; Modification des coordonnes si on va vers le haut.
	add.l	d6,d1		; d2 = Vy
	move.l	d1,d3		; d3 = temp Save
	swap	d1		; Fixed -> Integer
	sub.w	#(8+16),d1
	test_mur.s <read_destroy_a4>,tombe_ConT
		move.l	d3,Y(a5)	; Restore y
		bra.s	tombe_EnD
tombe_ConT
		clr.l	Vy(a5)
tombe_EnD:

	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts

;************************************************************************
; Accrocher
;************************************************************************
Accrocher:
	clr.l	V(a5)
	clr.l	Vx(a5)

	move.w	#SUSPENDU,Ani(a5)

	btst.l	#left_key,d4
	bne.s	\nol
		subq.w	#2,X(a5)
		or.b	#%10,Type_aff(a5)
		bra.s	\done
\nol:
	btst.l	#right_key,d4
	bne.s	\nor
		addq.w	#2,X(a5)
		and.b	#%11111000,Type_aff(a5)
\done:	move.w	#ACCROCHER,Ani(a5)
\nor:

	; Test saut
	btst.l	#Jump_key,d4
	bne.s	\sortie
		move.l	#2*ONE,d3
		btst.l	#up_key,d4
		bne.s	\noup
			neg.l	d3
\noup:		move.l	d3,Vy(a5)
		move.w	#4,J_cpt(a5)
\sortie:
	rts

	; Calcul de d6 = coordonnes du perso pour les SR
accro_d6:
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	move.w	#_TOMBE,Action(a5)
	rts

;************************************************************************
; 2eme Facon de bumper
;************************************************************************
Bumper2:
	move.w	#BUMP_2,Ani(a5)
	bra.s	Bumper_in

;************************************************************************
; 1er facon de bumper
;************************************************************************
Bumper:
	move.w	#BUMP,Ani(a5)
	tst.w	Vy(a5)
	blt.s	\ok
		move.w	#_TOMBE,Action(a5)
		bra	Tombe
\ok:

Bumper_in:
	calcul_vitesse2 <left_macro>,<right_macro>
	and.b	#%11111000,Type_aff(a5)
	move.l	d2,d0
	bgt.s	\ok
		neg.l	d0
		or.b	#%10,Type_aff(a5)
\ok:	move.l	d0,Abs_v(a5)
	bra	Tombe_in


;************************************************************************
; Saut apres s'etre fait touche
;************************************************************************
Ouille:
	move.w	#OUILLE,Ani(a5)
	move.l	V(a5),d2
	bsr	Tombe_in
;	eor.b	#%010,Type_aff(a5)
	rts

;************************************************************************
; Initialiser la phase mort
;************************************************************************
Init_dead:
	st.b	Force(a5)	; Destroying
	move.l	Plan_A_adr(a6),a0
	move.w	PLANE_YS(a0),d0
	move.w	d0,ymin(a6)
	move.w	d0,ymax(a6)
	subq.w	#1,Life(a6)
	st.b	Refresh_window(a6)
	clr.w	C_cpt(a5)
	move.w	#(DEAD_JUMP),W_cpt(a5)
	move.w	#(_DEAD),Action(a5)

;************************************************************************
; Le saut final de la mort
;************************************************************************
Dead:
	st.b	Force(a5)

	subq.w	#1,W_cpt(a5)
	bgt.s	\monte
		add.w	#DEAD_PAS,Y(a5)
		cmp.w	#(-(2*DEAD_JUMP)),W_cpt(a5)
		bgt.s	\end
			move.b	#EX_DEAD,Exit(a6)
\monte:
	subq.w	#DEAD_PAS,Y(a5)
\end:	
	move.w	#DEAD,Ani(a5)

	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts

;************************************************************************
; Boosting power....
;************************************************************************
Speed_Up:
	st.b	Boule(a5)
	move.w	#SPEED_UP,Ani(a5)
	btst.l	#down_key,d4
	bne.s	\quit
	bset.b	#down_key,(key+3)(a6)	; Pas trs joli !
	btst.l	#Jump_key,d4
	bne.s	\sortie
		bset.b	#(Jump_key-8),(key_mask+2)(a6)	; Il faut rappuyer sur saut pour que  remarche.
		Btst.b	#Type_aff_H,Type_aff(a5)
		beq.s	\sup
			cmp.l	#-MAX_F_SPEED,V(a5)
			ble.s	\sortie
				subq.w	#2,V(a5)
				bra.s	\sortie
\sup:		; No flip ->right
		cmp.l	#MAX_F_SPEED,V(a5)
		bge.s	\sortie
			addq.w	#2,V(a5)
\sortie:
	move.l	V(a5),d0
	bgt.s	\ok
		neg.l	d0
\ok:	move.l	d0,Abs_v(a5)

	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts

\quit:	move.l	V(a5),Vx(a5)
	move.w	#_WALK_A,Action(a5)
	bra	Walk_a

;************************************************************************
; Tube deplacement
;************************************************************************
Tube:
	st.b	Boule(a5)
	move.w	#BOULE,Ani(a5)
	move.l	Vx(a5),d0
	move.l	Vy(a5),d1
	add.l	d0,X(a5)
	add.l	d1,Y(a5)

	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts

;************************************************************************
; Oupla boum !
;************************************************************************
Trapeze:
	move.w	X(a5),d0
	move.w	J_cpt(a5),d1

	btst.l	#left_key,d4
	bne.s	\nol
		subq.w	#8,d0
		test_mur.s <read_a4>,\nor
		subq.w	#1,X(a5)
		bra.s	\nor
\nol:
	btst.l	#right_key,d4
	bne.s	\nor
		addq.w	#8,d0
		test_mur.s <read_a4>,\nor
		addq.w	#1,X(a5)
\nor:
	; Correction y
	clr.w	d0
	cmp.w	#TRAP_BH,Ani(a5)
	beq.s	\done
		moveq	#3,d0
\done:	add.b	Animation(a5),d0
	add.w	d0,d0
	move.w	Correct_y_trap(Pc,d0.w),d0
	add.w	J_cpt(a5),d0
	move.w	d0,Y(a5)
	; Test sortie : passage a Animation = 0 et ani_cpt != 0
	tst.b	Animation(a5)
	bne.s	\no_exit
		tst.b	Ani_cpt(a5)
		beq.s	\no_exit
			clr.b	Boule(a5)
			move.w	#_TOMBE,Action(a5)
			moveq	#26,d0
			tst.w	Vy(a5)
			bgt.s	\sup
				move.w	#_BUMP,Action(a5)
				moveq	#-10,d0
\sup:			add.w	J_cpt(a5),d0
			move.w	d0,Y(a5)
			clr.w	ymin(a6)
\no_exit:
	rts

Correct_y_trap:
	dc.w	-26,-32,-20,-7,0,0,-26,-32,-20


;************************************************************************
; Rotation Verticale
;************************************************************************
Vrot:	; Acceleration
	move.l	Vy(a5),d0

	move.w	J_cpt(a5),d1
	ext.l	d1
	asl.l	#1,d1
	add.l	d1,d0
	move.l	d0,d2
	sub.l	#PESANTEUR,d0
	move.l	d0,Vy(a5)

	; Modification acceleration suivant vitesse
	swap	d2
	cmp.w	#9,d2
	blt.s	\no1
		tst.l	d1
		blt.s	\no
			move.w	#_BUMP2,Action(a5)
\no1	cmp.w	#-9,d2
	bgt.s	\no
		tst.l	d1
		bgt.s	\no
			neg.w	J_cpt(a5)
\no:	bra	Bumper_in

;************************************************************************
; Plate-forme
;************************************************************************
Plat_form:
	; Calcul vitesse
	calcul_vitesse_long <boule_macro>,<left_walk_macro>,<right_walk_macro>,<nokey_macro>

	; Vx = V
	move.l	d2,Vx(a5)
	clr.l	Vy(a5)

	; Test collision mur X
	move.l	X(a5),d0
	move.l	Y(a5),d1
	add.l	d2,d0		; d2 = V=Vx
	move.l	d0,d3		; D3 : save X
	swap	d0		; Fixed to integer
	swap	d1
	tst.l	d2
	beq.s	\TT
	blt.s	\inf
	addq.w	#7,d0
	bra.s	\Test
\inf:	
	subq.w	#7,d0
\Test:	test_mur.b <read_a4>,\if_murx
\TT	move.l	d3,d0		; Restore x
	move.l	d0,X(a5)
	bra.s	\no_murx
\if_murx:
	clr.l	V(a5)
\no_murx:

	cmp.w	#5,Abs_v(a5)
	bhi.s	\ok8
	clr.b	Boule(a5)
\ok8:
	
	moveq	#WALK,d3
	clr.w	Diag(a5)
	
	tst.l	V(a5)
	bne.s	\move0
	clr.b	Boule(a5)
	btst.l	#up_key,d4
	bne.s	\no_up
	moveq	#HAUT,d3
	bra.s	\move1
\no_up:
	moveq	#DEBOUT,d3
	addq.w	#1,W_cpt(a5)
	cmp.w	#MAX_WAIT,W_cpt(a5)
	bls.s	\move1
	moveq	#WAIT,d3
	bra.s	\move1
\move0:
	clr.w	W_cpt(a5)
\move1:
	btst.l	#down_key,d4
	bne.s	\no_down
	cmp.w	#BOULE_LIMIT,Abs_v(a5)
	bhi.s	\do_boule
	moveq	#BAS,d3
;	btst.l	#Jump_key,d4
;	bne.s	\no_speed_up
;	move.w	#_SPEED_UP,Action(a5)
;	move.w	d3,Ani(a5)
;	bra	Speed_Up
;\no_speed_up:
	clr.b	Boule(a5)
	clr.l	V(a5)
	bra.s	\no_down
\do_boule:
	st	Boule(a5)
\no_down:
	tst.b	Boule(a5)
	beq.s	\no
	moveq	#BOULE,d3
\no:	
	move.w	d3,Ani(a5)

	; Teste le saut...
	btst.l	#Jump_key,d4
	bne.s	\no_jump
	st.b	Boule(a5)
	move.l	Jx(a5),d0
	add.l	d0,Vx(a5)
	move.l	Jy(a5),d0
	add.l	d0,Vy(a5)
	move.w	#STD_JUMP_CPT,J_cpt(a5)
	move.w	#_SAUTE,Action(a5)
	bra	Saute
\no_jump:
	move.w	#_TOMBE,Action(a5)

	; Calcul de d6
	move.w	X(a5),d6
	swap	d6
	move.w	Y(a5),d6
	sub.w	#16,d6
	rts
	

ADD_CORRECT	MACRO
	dc.b	-(\1)/2	; G_X
	dc.b	-((((\1)-1)/16+1)*16-(\1)/2) ; G_X when Flip H
	dc.b	-(\2)+1	; G_Y
	dc.b	0	; G_Y when Flip_V
	ENDM

ADD_R_CORRECT	MACRO
	dc.b	-(\1)+1	; G_X
	dc.b	-(32-(\1))-1 ; G_X when Flip H
	dc.b	-(\2)/2	; G_Y
	dc.b	-(\2)/2	; G_Y when Flip_V
	ENDM

Correction_table:
	ADD_CORRECT	18,32 ;DEBOUT,0,1,10
	ADD_CORRECT	17,32 ;HAUT,19,1,10
	ADD_CORRECT	20,24 ;BAS,18,1,10
	ADD_CORRECT	20,31 ;WAIT,1,2,20
	ADD_CORRECT	24,31 ;WALK,3,6,4
	ADD_CORRECT	18,30 ;RUN,28,4,2
	ADD_CORRECT	20,24 ;BOULE,20,8,2
	ADD_R_CORRECT	31,24 ;R_WALK,9,6,4
	ADD_R_CORRECT	30,18 ;R_RUN,32,4,2
	ADD_R_CORRECT	20,24 ;R_BOULE,20,8,2
	ADD_CORRECT	30,30 ;RF_WALK,43,6,4
	ADD_CORRECT	27,29 ;RF_RUN,49,4,2
	ADD_CORRECT	20,24 ;RF_BOULE,20,8,2
	ADD_CORRECT	30,30 ;RG_WALK,53,6,4
	ADD_CORRECT	27,29 ;RG_RUN,59,4,2
	ADD_CORRECT	20,24 ;RG_BOULE,20,8,2
	ADD_CORRECT	16,40 ;BUMP,15,1,20
	ADD_CORRECT	21,32 ;DEAD,16,1,20
	ADD_CORRECT	23,26 ;OUILLE,17,1,20
	ADD_CORRECT	24,31 ;FREINE,38,2,10
	ADD_CORRECT	24,31 ;EQUILI,36,2,20
	ADD_CORRECT	30,21 ;SPEED_UP,40,3,2
	ADD_CORRECT	16,32 ;POUSSE
	ADD_CORRECT	23,26	;BUMP 2
	ADD_CORRECT	23,26	;VROT
	ADD_CORRECT	27,32 	;Suspendu
	ADD_CORRECT	22,32 	;Accroche
	ADD_CORRECT	16,0	; Trap BH
	ADD_CORRECT	16,0	; Trap HB
