;*******************************************************
;		Point morphing sprite
;*******************************************************

	NEW_SPRITE
	ADD_CAR	Pf_Vx,2
	ADD_CAR	Pf_Vy,2
	ADD_CAR	Pf_offset,2
	ADD_CAR	Pf_orginal_offset,2
	ADD_CAR	Nbr_point,2
	ADD_CAR	Nbr_line,2
	ADD_CAR	List_point,0
	TAILLE_SPRITE	Taille_point

; Met a jour les points.
point_exe:
	move.l	a5,-(a7)

	; Mise a jour des coordonnes des points
	move.w	Nbr_point(a5),d5
	move.w	d5,d4		; Save nbr of points
	lea	(List_point-Pf_Vx)(a5),a5	; A5 -> Premier point
	lea	a5,a3		; Save a5
\point_loop:
		bsr	plat_form_move
		lea	#(Pf_original_offset-Xj)(a5),a5	; Next
		dbf	d5,\point_loop

	; Calcul de xmin, xmax, ymin et ymax
	move.w	d4,d5	; Nbr_points
	moveq	#-1,d1	; xmin
	moveq	#0,d2	; xmax
	moveq	#-1,d3	; ymin
	moveq	#0,d4	; ymax

	move.l	a3,a5
\point_loop:
		move.w	Xj(a5),d0
		cmp.w	d1,d0
		bhi.s	\ok
			move.w	d0,d1
\ok:		cmp.w	d0,d2
		bhi.s	\ok2
			move.w	d0,d2
\ok2:
		move.w	Yj(a5),d0
		cmp.w	d3,d0
		bhi.s	\ok
			move.w	d0,d3
\ok:		cmp.w	d0,d4
		bhi.s	\ok2
			move.w	d0,d4
\ok2:		lea	#(Pf_original_offset-Xj)(a5),a5	; Next
		dbf	d5,\point_loop

	move.l	(a7)+,a5

	; Calcul position principale et taille pour test de sortie
	move.w	d1,d0
	add.w	d2,d0
	lsr.w	#1,d0	; D0 = (xmax + xmin)/2
	sub.w	d1,d2
	lsr.w	#1,d2	; D2 = (xmax - xmin)/2
	move.w	d3,d1
	add.w	d4,d1
	lsr.w	#1,d1	; D1 = (ymax + ymin)/2
	sub.w	d3,d4
	lsr.w	#1,d4	; D4 = (ymax - ymin)/2

	; Test sortie de l'ecran
	add.w	#240,d2
	add.w	#128,d4

	move.l	d6,d3
	swap	d3

	sub.w	d0,d3
	bge.s	\no_neg
		neg.w	d3
\no_neg:
	cmp.w	d2,d3
	bhi.s	\exit_screen

	sub.w	d6,d1
	bge.s	\no_neg2
		neg.w	d1
\no_neg2:
	cmp.w	d4,d1
	bhi.s	\exit_screen

	; Fin de traitement principal
	rts

\exit_screen:
	move.w	Nbr_point(a5),d5
\exit_loop:
		move.w  Pf_original_offset(a3),d0
		move.b	#OBJ_MORPHING_POINT/4,0(a4,d0.w)
		lea	#(Pf_original_offset-Xj)(a3),a3	; Next
		dbf	d5,\exit_loop
	bra	DestroySprite

point_print:
	move.l	d5,-(a7)

	; Mise a jour des coordonnes des points
	lea	(List_point-Drawing)(a5),a0	; A0 -> points
	move.w	Nbr_point-Drawing(a5),d0
	addq.w	#1,d0
	mulu.w	#6*2,d0
	lea	0(a0,d0.w),a1			; A1 -> Line table
	
	move.w	Nbr_line-Drawing(a5),d4
	moveq	#5,d5			; Color
\line_loop:
		; Premier point
		moveq	#0,d0
		move.b	(a1)+,d0
		mulu.w	#6*2,d0
		move.w	2(a0,d0.w),d1
		move.w	0(a0,d0.w),d0
		; Second point
		moveq	#0,d2
		move.b	(a1)+,d2
		mulu.w	#6*2,d2
		move.w	2(a0,d2.w),d3
		move.w	0(a0,d2.w),d2
		; Line
		jsr	genlib::draw_clipped_line
		dbf	d4,\line_loop
		
	move.l	(a7)+,d5
	rts

point_init:
	; Sauve le point original
		