
; Tiles animation
Tiles_animation:
	move.l	Anim_tile_adr(a6),a5	; Get the adress of the tile_animation_table
	moveq	#(6-1),d4		; 5 frequences : 30, 15, 7, 3, 1 Hz
	moveq	#-1,d3			; 
	clr.w	d3			; D3 = $FFFF0000
	clr.b	d5			; Flag if we need to redraw the virtual-screens of the plane
\loop:
	moveq	#0,d0
	move.b	(a5)+,d0		; D0.l = Code
	cmp.b	#$FF,d0			; Code = $FF so next frequence
	beq.s	\end_or_next		
	pea	\loop(PC)		; After using 'rts' we will go to loop
	st.b	d5			; refresh the plane
	move.w	Anim_tile_table(Pc,d0.w),d0
	jmp	Anim_tile_table(Pc,d0.w)	; Go
\end_or_next:
	rol.l	#1,d3			; Next mask
	move.l	d7,d0
	swap	d0
	and.w	d3,d0			; Do we need to skip ?
	bne.s	\stop_			; Stop the freqence
	dbf.s	d4,\loop		; Next frequence
\stop_:	
	tst.b	d5			; Refresh planes ?
	beq.s	\no
	move.l	Plan_A_adr(a6),a0	; Yes, get the adress
	jmp	genlib::refresh_plane	; and call the genlib's function
\no:	rts				; Quit

; Anim tile table
Anim_tile_table:
	dc.w	Up_rot-Anim_tile_table		; 0
	dc.w	Down_rot-Anim_tile_table	; 2
	dc.w	Left_rot-Anim_tile_table	; 4
	dc.w	Right_rot-Anim_tile_table	; 6
	dc.w	Echange_rot-Anim_tile_table	; 8
	dc.w	Mega_Up_rot-Anim_tile_table	; 10
	dc.w	Mega_Down_rot-Anim_tile_table	; 12
	dc.w	Multi_texturing-Anim_tile_table	; 14
	dc.w	Virtual_Plane3-Anim_tile_table	; 16
	dc.w	TFlipH-Anim_tile_table		; 18
	dc.w	UpDateB-Anim_tile_table		; 20

; Peut modifier a0-a4 / d0-d2

Up_rot:
	move.l	Gfx1_adr(a6),a0	; Get the adress of the ghx table
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	adda.w	d1,a0		; a0 = adress of the graphic
	moveq	#(16-2),d1	; 16 rows
	move.l	(a0),d0		; Save the first line
	lea	4(a0),a1	; a1 -> Next line
\loop:	move.l	(a1)+,(a0)+	; Copy
	dbf.s	d1,\loop
	move.l	d0,(a0)		; Restore the first line beside
	rts
	
Down_rot:
	move.l	Gfx1_adr(a6),a0
	moveq	#0,d1
	move.b	(a5)+,d1	; Read no of tile
	lsl.w	#6,d1
	lea	(16*4)(a0,d1.w),a0
	moveq	#(16-2),d1
	move.l	a0,a1
	move.l	-(a1),d0
\loop:	move.l	-(a1),-(a0)
	dbf.s	d1,\loop
	move.l	d0,(a0)
	rts

Left_rot:
	move.l	Gfx1_adr(a6),a0
	moveq	#0,d1
	move.b	(a5)+,d1	; Read no of tile
	lsl.w	#6,d1
	adda.w	d1,a0
	moveq	#(16*2-1),d1
\loop:	move.w	(a0),d0
	rol.w	#1,d0
	move.w	d0,(a0)+
	dbf.s	d1,\loop
	rts

Right_rot:
	move.l	Gfx1_adr(a6),a0
	moveq	#0,d1
	move.b	(a5)+,d1	; Read no of tile
	lsl.w	#6,d1
	adda.w	d1,a0
	moveq	#(16*2-1),d1
\loop:	move.w	(a0),d0
	ror.w	#1,d0
	move.w	d0,(a0)+
	dbf.s	d1,\loop
	rts

Echange_rot:
	movem.l	d3-d4,-(a7)
	move.l	Gfx1_adr(a6),a0
	moveq	#0,d2
	move.b	(a5)+,d2	; Read no of tile
	lsl.w	#6,d2
	adda.w	d2,a0

	moveq	#0,d4
	move.b	(a5)+,d4	; Read number of tiles

	movem.l	(a0),d0-d3/a1-a4
	movem.l	d0-d3/a1-a4,-(a7)
	movem.l	(8*4)(a0),d0-d3/a1-a4
	movem.l	d0-d3/a1-a4,-(a7)
	lea	(16*4)(a0),a1
\big_loop:
	moveq	#(16-1),d2
\loop:	move.l	(a1)+,(a0)+
	dbf.s	d2,\loop
	dbf.s	d4,\big_loop
	movem.l	(a7)+,d0-d3/a1-a4
	movem.l	d0-d3/a1-a4,(8*4)(a0)
	movem.l	(a7)+,d0-d3/a1-a4
	movem.l	d0-d3/a1-a4,(a0)
	movem.l	(a7)+,d3-d4
	rts

Mega_Up_rot:
	move.l	Gfx1_adr(a6),a0	; Get the adress of the ghx table
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	adda.w	d1,a0		; a0 = adress of the graphic
	moveq	#0,d1
	move.b	(a5)+,d1	; Read number of tiles
	lsl.w	#4,d1
	subq.w	#2,d1		; Number of rows
	move.l	(a0),d0		; Save the first line
	lea	4(a0),a1	; a1 -> Next line
\loop:	move.l	(a1)+,(a0)+	; Copy
	dbf.s	d1,\loop
	move.l	d0,(a0)		; Restore the first line beside
	rts
	
Mega_Down_rot:
	move.l	Gfx1_adr(a6),a0
	moveq	#0,d1
	move.b	(a5)+,d1	; Read no of tile
	lsl.w	#6,d1
	lea	(16*4)(a0,d1.w),a0
	moveq	#0,d1
	move.b	(a5)+,d1	; Read number of tiles
	lsl.w	#4,d1
	subq.w	#2,d1		; Number of rows
	move.l	a0,a1
	move.l	-(a1),d0
\loop:	move.l	-(a1),-(a0)
	dbf.s	d1,\loop
	move.l	d0,(a0)
	rts

Multi_texturing:
	move.l	Gfx1_adr(a6),a0	; Get the adress of the ghx table
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	lea	0(a0,d1.w),a2	; a2 = adress of the graphic
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	lea	0(a0,d1.w),a1	; A1 = adr of the tile to copy
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	adda.w	d1,a0		; A0 = adress of the transparent tile
	moveq	#(16-1),d1
\loop:
	move.l	(a1)+,d0
	or.l	(a0)+,d0	; Too transparent but really faster !
	move.l	d0,(a2)+
	dbf.s	d1,\loop
	rts

; Fait un plan virtuel en decalant les tiles
; Entree:
;	Type.b / Debut.b / Sous-Type / Nbr (0 -> 2)
Virtual_Plane3:
	move.l	Plan_B_adr(a6),a0
	move.w	PLANE_XS(a0),d5
	sub.w	PlaneB_X_old(a6),d5
	beq	\ok_and_quit

;\wait	bra.s	\wait

	move.l	Gfx2_adr(a6),a2	; Get the adress of the gfx table
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	adda.w	d1,a2
	
	move.w	d5,d1
	move.b	(a5)+,d0
	asr.w	d0,d1
	sub.w	d1,d5		; D5 = x + x/{2,4,8}
	
	move.w	PLANE_XS(a0),PlaneB_X_old(a6)	; Save it
	jsr	genlib::refresh_plane		; Refresh it

	movem.l	d3-d4/d6-d7,-(a7)	; Push registers
	
	moveq	#0,d6
	move.b	(a5)+,d6		; Lecture nbr de tile horizontal

	moveq	#16-1,d3		; Hauteur d'un tile

	tst.w	d5			; Lsl / lsr ?
	ble.s	\trait_lsl

	moveq	#60,d7			; Fast Add 
	cmp.w	#15,d5
	bls.s	\ok1
		moveq	#15,d5
\ok1
		; Boucle sur la hauteur d'un tile 
\loop_htile	move.l	a2,a0		; Copie dans a0
		move.w	(a0)+,d0
		move.w	(a0)+,d1
		adda.l	d7,a0		; A0 += 60
		move.w	d6,d4
\loop_lsr:		; Traitement 1 word
			swap	d0
			move.w	(a0),d0
			move.l	d0,d2
			lsr.l	d5,d2
			move.w	d2,(a0)+
			; Traitement 2nd word
			swap	d1
			move.w	(a0),d1
			move.l	d1,d2
			lsr.l	d5,d2
			move.w	d2,(a0)+
			; Next tile
			adda.l	d7,a0	; A0+=60
			dbf	d4,\loop_lsr
		; Traitement du dernier avec rebouclage sur le debut 
		; Et incrementation du pointeur du debut
		swap	d0
		move.w	(a2),d0
		lsr.l	d5,d0
		move.w	d0,(a2)+
		swap	d1
		move.w	(a2),d1
		lsr.l	d5,d1
		move.w	d1,(a2)+
		dbf	d3,\loop_htile
	bra.s	\end
; Traitement avec des lsl
\trait_lsl:
	neg.w	d5
	; Pointe sur le dernier a traiter
	move.w	d6,d0
	addq.w	#2,d0
	lsl.w	#6,d0	; D0 = 64 * (Nbr+2) = 64 * Nbr_tile_a_traiter
	subq.w	#2,d0	; 
	adda.w	d0,a2	; A2 -> Dernier (Derniere ligne)

	; Verouille a 15 max.
	cmp.w	#15,d5
	bls.s	\ok2
		moveq	#15,d5
\ok2
	moveq	#64,d7			; Fast Add 
		; Boucle sur la hauteur d'un tile 
\loop_htile2	move.l	a2,a0		; Copie dans a0
		move.w	(a0),d0
		move.w	-2(a0),d1
		suba.l	d7,a0		; A0 -= 64
		swap	d0
		swap	d1
		move.w	d6,d4
\loop_lsl:		; Traitement 1 word
			move.w	(a0),d0
			swap	d0
			move.l	d0,d2
			lsl.l	d5,d2
			swap	d2
			move.w	d2,(a0)
			; Traitement 2nd word
			move.w	-2(a0),d1
			swap	d1
			move.l	d1,d2
			lsl.l	d5,d2
			swap	d2
			move.w	d2,-2(a0)
			; Next tile
			suba.l	d7,a0	; A0-=64
			dbf	d4,\loop_lsl
		; Traitement du dernier avec rebouclage sur le debut 
		; Et decrementation du pointeur du debut
		move.w	(a2),d0
		swap	d0
		lsl.l	d5,d0
		swap	d0
		move.w	d0,(a2)
		subq.w	#2,a2
		move.w	(a2),d1
		swap	d1
		lsl.l	d5,d1
		swap	d1
		move.w	d1,(a2)
		subq.w	#2,a2
		dbf	d3,\loop_htile2
\end:
	movem.l	(a7)+,d3-d4/d6-d7
	clr.b	d5		; Devalide le rafraichissement du plan 1
	rts
\ok_and_quit:
	addq.w	#(1+1+1),a5
	clr.b	d5		; Devalide le rafraichissement du plan 1
	rts

TFlipH:

	move.l	Gfx1_adr(a6),a0	; Get the adress of the ghx table
	moveq	#0,d1		
	move.b	(a5)+,d1	; Read no of tile in d1.l
	lsl.w	#6,d1		; Convertion (a tile 16x16 in 4c is 2^6 bytes)
	adda.w	d1,a0		; a0 = adress of the graphic

	lea	genlib::flipping_tab,a1

	moveq	#0,d1
	moveq	#0,d2

	moveq	#15,d0
\copy:
		move.b	(a0)+,d1
		move.b	(a0),d2
		move.b	0(a1,d1.w),(a0)+	; reverse 1st byte of 1st plane
		move.b	0(a1,d2.w),-2(a0)	; reverse 2nd byte of 1st plane

		move.b	(a0)+,d1
		move.b	(a0),d2
		move.b	0(a1,d1.w),(a0)+	; reverse 1st byte of 2nd plane
		move.b	0(a1,d2.w),-2(a0)	; reverse 2nd byte of 2nd plane

		dbf	d0,\copy		; Next row

	rts

UpDateB:
	move.l	Plan_B_adr(a6),a0
	jmp	genlib::refresh_plane

;Deca_sac:
;	move.l	Gfx1_adr(a6),a0
;	moveq	#0,d1
;	move.b	(a5)+,d1
;	lsl.w	#6,d1
;	adda.w	d1,a0

;	moveq	#(32-2)-1,d0
;	move.l	d7,d1
;	swap	d1
;	lsr.w	#2,d1
;Deca2_loop:
;	andi.w	#30,d1
;	move.w	Deca_Sac_Table(PC,d1.w),Deca_Code
;	addq.w	#2,d1
;	move.w	(a0),d2
;Deca_Code:
;	rol.w	#1,d2
;	move.w	d2,(a0)+
;	dbf.s	d0,Deca2_loop
;	rts
;
;Deca_Sac_Table:
;	ror.w	#1,d2
;	ror.w	#1,d2
;	nop
;	nop
;	rol.w	#1,d2
;	rol.w	#1,d2
;	nop
;	nop
;	rol.w	#1,d2
;	rol.w	#1,d2
;	nop
;	nop
;	ror.w	#1,d2
;	ror.w	#1,d2
;	nop
;	nop

; Standart tile table
Anim_base:
	dc.b	$FF	; 30 Hz
	dc.b	$FF	; 15 Hz
	dc.b	$FF	; 7,5 Hz
	dc.b	8,1,2
	dc.b	$FF	; 1,12 Hz
	dc.b	8,16,0
	dc.b	8,18,0
	dc.b	8,20,0
	dc.b	8,22,0
	dc.b	8,24,0
	dc.b	$FF
	dc.b	$FF	; 0,55 Hz

	EVEN
	